-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;

WITH calendar;
USE  calendar;
WITH system;
 
PRAGMA elaborate(zg_glob1, zg_glob2, zg_glob3, zg_glob4, calendar, system);
 
PACKAGE pkg01_tk_la01 IS
  TASK background IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
    ENTRY initialization_complete;
    ENTRY start_problem;
    ENTRY stop_problem;
    ENTRY stop_program;
  END background;
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    entry start_problem;
  END main;
END pkg01_tk_la01;
 
PACKAGE BODY pkg01_tk_la01 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
  
  TASK BODY background IS
  BEGIN
    ACCEPT initialization_complete;
 
    ACCEPT start_problem;
 
    LOOP
      SELECT    -- background task will be executing a
                -- DELAY until entry call is made on
                -- STOP_PROBLEM
        ACCEPT stop_problem;
        EXIT;
      OR
        DELAY 10.0;
      END SELECT;
    END LOOP;
 
    ACCEPT stop_program;
  END background;
 
  TASK BODY main IS
 
  BEGIN
 
    --
    -- Test Name         :  tk_la_async_03
    -- Prime Purpose     :  Perform 10_000 procedure calls another task is
    --                      waiting in a long DELAY loop. Need to perform a
    --                      fairly long test problem to permit possible
    --                      overheads from polling to show up.
    --
    -- LRM Version       :  A
    -- Optimization      :
    -- Related tests     :  tk_la_async_04
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --

    accept start_problem;
 
    background.initialization_complete;
 
    background.start_problem;    -- signal start of problem
 
    -------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_la_async_03");

    PRAGMA include("startime");

    FOR i IN 1 .. 10_000 LOOP
      zg_glob4.proc0;
    END LOOP;

    PRAGMA include("stoptime0");
                                      
    zg_glob2.put_comment_optional
	("   Perform 10_000 procedure calls while another task is waiting in");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   a long DELAY loop. Need to perform a fairly long test problem ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   to permit possible overheads from polling to show up. ");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    -------------------------------------------------------------------------
 
    background.stop_problem;     -- signal completion of problem
 
    background.stop_program;
 
  END main;
END pkg01_tk_la01;
 
-----------------------------------
 
WITH pkg01_tk_la01;
 
PRAGMA elaborate(pkg01_tk_la01);
 
PROCEDURE tk_la_async_03 IS
BEGIN
  pkg01_tk_la01.main.start_problem; 
END tk_la_async_03;
