-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- tk_lb_task_38

WITH zg_glob1; 
PACKAGE pkg01_tk_lb02 IS
 
  TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
    ENTRY request;
    ENTRY release;
  END resource;
END pkg01_tk_lb02;
 
PACKAGE BODY pkg01_tk_lb02 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK BODY resource IS
  BEGIN
    LOOP
      ACCEPT request;
      ACCEPT release;
    END LOOP;
  END resource;
END pkg01_tk_lb02;
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
 
WITH calendar;
USE  calendar;
WITH pkg01_tk_lb02;
USE  pkg01_tk_lb02;
WITH system;
 
PROCEDURE tk_lb_task_38 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END main;
 
 
  TASK BODY main IS
  BEGIN
 
    --
    -- Test Name         :  tk_lb_task_38
    -- Prime Purpose     :  Language feature test of aspects of tasking.  This
    --                      program makes an entry call on an aborted task. 
    --                      Will raise a TASKING_ERROR exception.
    -- LRM Version       :  A
    -- Optimization      :
    -- Related tests     :
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
 
    IF zg_glob4.ll /= zg_glob4.mm THEN    -- always true: ll is not equal to mm
      ABORT resource;
    END IF;
 
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_lb_task_38");

    PRAGMA include("startime");

    BEGIN
      FOR i IN 1 .. 10 LOOP
        resource.request;    -- resource was aborted, entry call should raise
                             -- tasking error
        resource.release;
        zg_glob4.die;
      END LOOP;
    EXCEPTION
      WHEN tasking_error =>
        zg_glob4.proc0;
    END;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   BEGIN");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("     FOR i IN 1..10 ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("     LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
         ("       resource.request;  -- resource was aborted, entry call ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
         ("                          -- should raise tasking error");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("       resource.release;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("       die;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("     END LOOP;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
         ("     exception when tasking_error => proc0;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
         ("   -- test of call on aborted task, raising tasking error");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
  END main;
 
BEGIN
  NULL;
END tk_lb_task_38;
