--  tk_lb_task_40 create and abort a task

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;

WITH calendar;
USE  calendar;
 
PROCEDURE tk_lb_task_40 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  PROCEDURE tasking IS
    TASK simple_task IS
    END simple_task;
 
    TASK BODY simple_task IS
    BEGIN
      IF zg_glob4.ll /= zg_glob4.mm THEN    -- always true
        ABORT simple_task;
      END IF;
      zg_glob4.proc0;
      DELAY 1.0;
    END simple_task;
 
  BEGIN
    NULL;    -- this is a very simple procedure also
  END tasking;
 
 
BEGIN
 
  --
  -- Test Name         :  tk_lb_task_40
  -- Prime Purpose     :  Language feature test of aspects of tasking.  This
  --                      program creates a task which aborts itself.
  -- LRM Version       :  A
  -- Optimization      :
  -- Related tests     :
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
 
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("tk_lb_task_40");

  PRAGMA include("startime");

  FOR i IN 1 .. 10 LOOP
    tasking;
  END LOOP;

  PRAGMA include("stoptime0");

  zg_glob2.put_comment_optional("   FOR i IN 1..10");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   LOOP");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      tasking;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   END LOOP;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional
         ("   -- tasking creates a task which aborts itself");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   -- compare with tk_lf_task_01");

  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
  
END tk_lb_task_40;
