-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- tk_lb_task_53 task aborts another task

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH system;
 
PROCEDURE tk_lb_task_53 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK TYPE simple_task IS 
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
  ENTRY hang;
END simple_task;
 
TASK BODY simple_task IS
BEGIN
  ACCEPT hang;    -- the task must not complete
END simple_task;
 
TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
END main;
 
TASK BODY main IS
BEGIN
 
 
  --
  -- Test Name         :  tk_lb_task_53
  -- Prime Purpose     :  To measure the time for a task to abort a different
  --                      task. The aborted task is also created on each
  --                      iteration.
  -- LRM Version       :  A
  -- Optimization      :
  -- Related tests     :
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
 
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("tk_lb_task_53");

  PRAGMA include("startime");

  FOR i IN 1 .. 10 LOOP
    DECLARE
      task_to_abort : simple_task;
    BEGIN
      ABORT task_to_abort;
    END;
  END LOOP;

  PRAGMA include("stoptime0");

  zg_glob2.put_comment_optional("   task aborts another task");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   FOR i IN 1..10 ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   LOOP");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      DECLARE");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional
         ("        task_to_abort: simple_task; -- create high priority task");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      BEGIN");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("        ABORT task_to_abort;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      END;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   END LOOP;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional
         ("   -- priorities are such that task_to_abort will be");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   -- waiting on an entry call when aborted");

  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
 
EXCEPTION
  WHEN tasking_error | storage_error =>
    zg_glob2.put_test_name("tk_lb_task_53");
    zg_glob2.put_comment("   task aborts another task");
    zg_glob2.put_new_line;
    zg_glob2.put_comment("   Error at execution time. Either TASKING_ERROR or");
    zg_glob2.put_new_line;
    zg_glob2.put_comment("   STORAGE_ERROR exception raised.");
    zg_glob2.put_new_line;
    zg_glob2.put_error_code (zg_glob1.err_at_execution_time);
 
  WHEN OTHERS =>
    zg_glob2.put_test_name("tk_lb_task_53");
    zg_glob2.put_comment("   task aborts another task");
    zg_glob2.put_new_line;
    zg_glob2.put_comment("   Error at execution time. Exception other than ");
    zg_glob2.put_new_line;
    zg_glob2.put_comment("   TASKING_ERROR or STORAGE_ERROR raised.");
    zg_glob2.put_new_line;
    zg_glob2.put_error_code (zg_glob1.err_at_execution_time);
END main;
 
BEGIN
  NULL;
END tk_lb_task_53;
