-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- +++ tcl 2-8-89 change to make ancillary information self-identifying
-- tk_lf_task_03

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH system;
 
PROCEDURE tk_lf_task_03 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
  END main;
 
  TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    ENTRY request;
    ENTRY release;
  END resource;
 
  TASK BODY resource IS
  BEGIN
    LOOP
      ACCEPT request;
      ACCEPT release;
    END LOOP;
  END resource;
 
  TASK BODY main IS
  BEGIN
 
 
    --
    -- Test Name         :  tk_lf_task_03
    -- Prime Purpose     :  Simple rendezvous with task making entry call
    --                      arriving at rendezvous first.
    -- LRM Version       :  A
    -- Optimization      :
    -- Related tests     :
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
  
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_lf_task_03");

    PRAGMA include("startime");

    FOR i IN 1 .. 10 LOOP
      resource.request;
      resource.release;
    END LOOP;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   both tasks in same compilation unit");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   FOR i IN 1..10 ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      resource.request;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      resource.release;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END LOOP;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- priorities are such that ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- task making entry call will");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- arrive at rendezvous first");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- compare with tk_lf_task_23");

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
                       ----------------------------------------------------
                       -- +++ tcl 2-8-89 change to make ancillary information
                       -- self-identifying
    zg_glob2.put_ancillary(" >>> tk_lf_task_03 time per rendezvous = ");
    zg_glob2.put_value((zg_glob3.min_time * 1000000.0 / 20.0), 8, 1, 0);
    zg_glob2.put_new_line;
                       ----------------------------------------------------
 
    ABORT resource;    -- stop execution
  END main;
 
BEGIN
  NULL;
END tk_lf_task_03;
