-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
--+tcl 12-oct-89 Make DELAY test problem report an error code
-- tk_ls_task_34_delta

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH system;
 
PACKAGE pkg01_tk_lf11 IS

  skip_print : exception ;
 
  TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    ENTRY entry1;
    ENTRY initialization_complete;
  END resource;
 
END pkg01_tk_lf11;
 
PACKAGE BODY pkg01_tk_lf11 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK BODY resource IS
  BEGIN
 
 
    ACCEPT initialization_complete;
 
    SELECT
      ACCEPT entry1;                     -- never called
    OR
      DELAY 0.001;                       -- one millisecond
    END SELECT;

    --
    -- Test Name         :  tk_lf_task_34_delta
    -- Prime Purpose     :  Simple delay to compare with tk_ls_task_34.
    -- LRM Version       :  A
    -- Optimization      :
    -- Related tests     :
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
 
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_lf_task_34_delta");

    begin
    PRAGMA include("startime");
    DELAY 0.001;                         -- one millisecond
    PRAGMA include("stoptime0");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   DELAY 0.001; -- one millisecond");
    zg_glob2.put_new_line_optional;
           --+tcl 12-oct-89, problems executing a DELAY given an error code
    if zg_glob3.verification_success then
      standard_dev( timing_vector(1..mcount), timing_mean, timing_sigma );
      zg_glob2.put_measurement (
        result_kind       => zg_glob2.test_result,
        size              => abs( float6(system_storage_unit) * expansion_size),
        minimum_time      => delay_problem / 1_000_000.0 ,
        mean_time         => timing_mean,
        inner_count_lower => ncount_lower,
        inner_count_upper => ncount_upper,
        outer_count       => mcount,
        sigma             => timing_sigma,
        unreliable_flag   => false );
      zg_glob2.put_ancillary(
      " >>> tk_lf_task_34_delta Time for 1-millisecond delay is ");
      zg_glob2.put_value( timing_mean * 1_000_000.0, 6, 1, 0 );
      zg_glob2.put_comment(" microseconds");
      zg_glob2.put_new_line;
      raise skip_print;
    end if;
    PRAGMA include("stoptime2");
    exception when skip_print => null ;
    end;

    ----------------------------------------------------------------------------
 
  END resource;
END pkg01_tk_lf11;
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
WITH pkg01_tk_lf11;
USE  pkg01_tk_lf11;
WITH system;
 
PROCEDURE tk_lf_task_34_delta IS
  
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
  END main;
 
  TASK BODY main IS
  BEGIN
    resource.initialization_complete;    -- sync with task resource
    LOOP
      EXIT WHEN resource'terminated;
      IF zg_glob4.ll = zg_glob4.mm THEN  -- never true
        resource.entry1;                 -- never taken,
        ABORT resource;                  -- if control reaches this statement,
        EXIT;                            -- program is fubar & will terminate
      ELSE
        DELAY 1.0;
      END IF;
    END LOOP;
  END main;
 
BEGIN
  NULL;
END tk_lf_task_34_delta;
