-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- tk_ls_task_35

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH system;
 
PACKAGE pkg01_tk_lf12 IS
 
  TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    ENTRY entry1;
    ENTRY initialization_complete;
  END resource;
 
END pkg01_tk_lf12;
 
PACKAGE BODY pkg01_tk_lf12 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK BODY resource IS
  BEGIN
 
 
    ACCEPT initialization_complete;
 
    SELECT
      ACCEPT entry1;    -- never called
    OR
      DELAY 0.000;
    END SELECT;
 
    --
    -- Test Name         :  tk_lf_task_35_delta
    -- Prime Purpose     :  delay 0.0 for comparison with tk_ls_task_35
    -- LRM Version       :  A
    -- Optimization      :  nonpositive delay -
    --                      DELAY of 0.0 (or negative value) can be special-
    --                      cased at compile time for static expressions.
    -- Related tests     :
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
 
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_lf_task_35_delta");

    PRAGMA include("startime");

    DELAY 0.000;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("     delay 0.0;");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
  END resource;
END pkg01_tk_lf12;
 
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
WITH pkg01_tk_lf12;
USE  pkg01_tk_lf12;
WITH system;

PROCEDURE tk_lf_task_35_delta IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
  END main;
 
 
  TASK BODY main IS
  BEGIN
    resource.initialization_complete;    -- sync with task resource
    LOOP
      EXIT WHEN resource'terminated;
      IF zg_glob4.ll = zg_glob4.mm THEN  -- never true
        resource.entry1;                 -- never taken
        EXIT;                            -- terminate loop if reach here
      ELSE
        DELAY 1.0;
      END IF;
    END LOOP;
  END main;
 
BEGIN
  NULL;
END tk_lf_task_35_delta;
