-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
--+ tcl 12-07-88 Modified to reflect SPR#26
 
-- task37
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;

WITH calendar;
USE  calendar;
WITH system;
 
PROCEDURE tk_lf13 IS
  
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  private_exception : EXCEPTION;
 
  PROCEDURE main_program IS
 
    TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
      ENTRY request;
    END resource;
 
    TASK BODY resource IS
    BEGIN
      ACCEPT request DO
        IF zg_glob1.bool THEN
          RAISE private_exception;
        END IF;
      END request;
    EXCEPTION
      WHEN private_exception =>
        NULL;
    END resource;
 
    TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    END main;
 
    TASK BODY main IS
    BEGIN
      BEGIN
        resource.request;
      EXCEPTION
        WHEN private_exception =>
          zg_glob4.proc0;
      END;
    END main;
 
  BEGIN
    NULL;
  END main_program;
 
BEGIN
  PRAGMA include("inittime");
 
  --
  -- Test Name         :  tk_lf_task_37a
  -- Prime Purpose     :  Language feature test of aspects of tasking.  This
  --                      program raises a user-defined exception inside a
  --                      rendezvous.
  -- LRM Version       :  A
  -- Optimization      :
  -- Related tests     :
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
 
  zg_glob1.bool := true;     -- always true, never changed in timing loop
 
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("tk_lf_task_37a");

  PRAGMA include("startime");

  main_program;

  PRAGMA include("stoptime0");

			    --+ tcl 12-07-88 SPR#26 modified wording of message
  zg_glob2.put_comment_optional
	("   -- Raises a user-defined exception inside a rendezvous.");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional
	("   -- The exception will be propagated to task performing");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   -- ENTRY call.    cf. tk_lf_task_37b ");
  zg_glob2.put_new_line_optional;
 
  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
  
  --
  -- Test Name         :  tk_lf_task_37b
  -- Prime Purpose     :  Language feature test of aspects of tasking.  Compare
  --                      this program to tk_lf_task_37a.  Creates and normally
  --                      terminates the tasks while tk_lf_task_37a forces 
  --                      abnormal termination of test.
  -- LRM Version       :  A
  -- Optimization      :
  -- Related tests     :
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
 
  zg_glob1.bool := false;    -- always false, never changed in timing loop
 
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("tk_lf_task_37b");

  PRAGMA include("startime");

  main_program;

  PRAGMA include("stoptime0");

			--+ tcl 12-07-88 SPR#26  modified wording of message
  zg_glob2.put_comment_optional
("   -- This test problem was constructed for comparison with tk_lf_task_37a");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional
("   -- Unlike tk_lf_task_37a, this test problem rendezvouses and terminates ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional
("   -- the task without raising and propagating an exception.");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional
("   -- Difference between tk_lf_task_37b and tk_lf_task_37a is the extra ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional
("   -- time to raise and propagate an exception from within a rendezvous.");
  zg_glob2.put_new_line_optional;
 
  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
 
END tk_lf13 ;
