-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- +++ tcl 2-8-89 change to make ancillary information self-identifying
-- tk_lf_task_42

WITH zg_glob1;
PACKAGE pkg01_tk_lf15 IS
 
  TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    ENTRY request;
    ENTRY release;
  END resource;
END pkg01_tk_lf15;
 
PACKAGE BODY pkg01_tk_lf15 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK BODY resource IS
  BEGIN
    LOOP
      ACCEPT request;
      ACCEPT release;
    END LOOP;
  END resource;
END pkg01_tk_lf15;
 
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH pkg01_tk_lf15;
USE  pkg01_tk_lf15;
WITH system;
 
PROCEDURE tk_lf_task_42 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END main;
 
  TASK BODY main IS
  BEGIN
 
    --
    -- Test Name         :  tk_lf_task_42
    -- Prime Purpose     :  Language feature test for aspects of tasking. 
    --                      Simple rendezvous with equal priority tasks, 
    --                      one task in library unit.
    -- LRM Version       :  A
    -- Optimization      :
    -- Related tests     :  tk_lf_task_26, tk_lf_task_41
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
 
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_lf_task_42");

    PRAGMA include("startime");

    FOR i IN 1 .. 10 LOOP
      resource.request;
      resource.release;
    END LOOP;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   FOR i IN 1..10");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      resource.request;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      resource.release;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END LOOP;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- equal priority tasks, resource in separate package");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- cf tk_lf_task_26,tk_lf_task_41");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- Consider two tasks T1 an T2 which repetitively rendezvous");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- With different priorities, order of execution must be");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --                 ...(T1-T2)-(T1-T2)-(T1-T2)...");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- With equal priorities, could execute the tasks in the order");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --                 ...(T1-T2)-(T2-T1)-(T1-T2)...");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- This saves 1/4 of the task swaps");
    zg_glob2.put_new_line_optional;
    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
		----------------------------------------------------
		-- +++ tcl 2-8-89 make ancillary information self-identifying
    zg_glob2.put_ancillary(" >>> tk_lf_task_42 time per rendezvous = ");
    zg_glob2.put_value( (zg_glob3.min_time * 1000000.0 / 20.0), 8, 1, 0);
    zg_glob2.put_new_line;
                ----------------------------------------------------
 
    ABORT resource;    -- stop execution
  END main;
 
BEGIN
  NULL;
END tk_lf_task_42;
