-- +++ tcl 2-8-89 change to make ancillary information self-identifying

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

with calendar; use calendar;
  
procedure tk_lf_task_48 is

   pragma suppress(access_check);
   pragma suppress(discriminant_check);
   pragma suppress(index_check);
   pragma suppress(length_check);
   pragma suppress(range_check);
   pragma suppress(division_check);
   pragma suppress(overflow_check);
   pragma suppress(elaboration_check);
   pragma suppress(storage_check);
   
   task resource is
      entry request;
                -- The following statement should be modified to use the
                -- system dependent method to tie a task to an interrupt.
 <> deliberate error, system adaptation required -- for request use at 16#40#;  
      entry release;
                -- The following statement should be modified to use the
                -- system dependent method to tie a task to an interrupt.
 <> deliberate error, system adaptation required -- for release use at 16#42#;  
   end resource;
     
   task body resource is
   begin
     loop
       accept request;       
       accept release;
     end loop;
   end resource;
     
   task main is
   end main;
   
   task body main is
   begin
                                  
	--
	-- Test Name         :  tk_lf_task_48
	-- Prime Purpose     :  Entries tied to interrupt are called directly.
	-- LRM Version       :  Revision A
	-- Optimization      : 
	-- Related tests     :  tk_lf_task_03
	-- Author            :  Kermit Terrell     
	-- Reviewer          :  T. Leavitt, 12-oct-89
	-- Date              :  9 July 1987
	-- Source            :  -
	-- Dependencies      :  Entries tied to interrupts are system dependent.
	--                      The program needs to be tailored to the system.
	--                      This may not be possible on some systems.
	-- Other Information :  

----------------------------------------------------------------------------
     zg_glob2.put_test_name("tk_lf_task_48");
   
      pragma include("startime");                                               
   
          for i in 1..10                                                        
          loop                                                                  
            resource.request;                                                   
            resource.release;                                                   
          end loop;                                                             

      pragma include("stoptime0");                                              
   
        zg_glob2.put_comment_optional("   -- entries are tied to interrupts ");
        zg_glob2.put_new_line_optional;
        zg_glob2.put_comment_optional("   FOR i IN 1..10 ");            
        zg_glob2.put_new_line_optional;
        zg_glob2.put_comment_optional("   LOOP");                       
        zg_glob2.put_new_line_optional;
        zg_glob2.put_comment_optional("      resource.request;");        
        zg_glob2.put_new_line_optional;
        zg_glob2.put_comment_optional("      resource.release;");        
        zg_glob2.put_new_line_optional;
        zg_glob2.put_comment_optional("   END LOOP;");                  
        zg_glob2.put_new_line_optional;
        zg_glob2.put_comment_optional("   -- cf tk_lf_task_03 & tk_lf_task_23");
        zg_glob2.put_new_line_optional;

      pragma include("stoptime2");                                              
----------------------------------------------------------------------------

		----------------------------------------------------
		-- +++ tcl 2-8-89 make ancillary information self-identifying
	zg_glob2.put_ancillary(" >>> tk_lf_task_48 time per rendezvous = " );
	zg_glob2.put_value( (zg_glob3.min_time * 1_000_000.0 / 20.0), 8, 1, 0);
	zg_glob2.put_new_line;
		----------------------------------------------------

      abort resource; -- stop execution 
   end main;
   
begin
  null;
end tk_lf_task_48;
