-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- +++ tcl 2-8-89 change to make ancillary information self-identifying
-- tk_lf_task_57 simple rendezvous on a task parameter

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH system;
 
PROCEDURE tk_lf_task_57 IS
 
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK TYPE simple_task IS 
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  ENTRY request;
  ENTRY release;
END simple_task;
 
actual_task : simple_task;
  
TASK BODY simple_task IS
BEGIN
  LOOP
    ACCEPT request;
    ACCEPT release;
  END LOOP;
END simple_task;
 
PROCEDURE subprogram(formal_task : simple_task) IS
BEGIN
 
 
  --
  -- Test Name         :  tk_lf_task_57
  -- Prime Purpose     :  To measure the time for a simple rendezvous with a
  --                      task created as a component of a dynamically allocated
  --                      record.  The time of task creation/termination is
  --                      excluded.
  -- LRM Version       :  Revision A
  -- Optimization      :
  -- Related tests     :
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
 
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("tk_lf_task_57");

  PRAGMA include("startime");

  FOR i IN 1 .. 10 LOOP
    formal_task.request;
    formal_task.release;
  END LOOP;

  PRAGMA include("stoptime0");

  zg_glob2.put_comment_optional("   simple rendezvous on a task parameter");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   FOR i IN 1..10 ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   LOOP");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      formal_task.request;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      formal_task.release;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   END LOOP;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   -- priorities ensure task making entry");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   -- call will arrive at rendezvous first");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   -- compare with tk_lf_task_52");
  zg_glob2.put_new_line_optional;

  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
 
		----------------------------------------------------
		-- +++ tcl 2-8-89 make ancillary information self-identifying
  zg_glob2.put_ancillary(" >>> tk_lf_task_57 time per rendezvous = ");
  zg_glob2.put_value( (zg_glob3.min_time * 1000000.0 / 20.0), 8, 1, 0);
  zg_glob2.put_new_line;
                ----------------------------------------------------
 
  ABORT formal_task;    -- stop execution
END subprogram;
 
BEGIN
  subprogram (actual_task);
END tk_lf_task_57;
