with zg_glob1; 
use  zg_glob1;                           --+ tcl 6 April 1992, PCR #100, part 3
package tk_lfpkg_58 is

  TASK TYPE simple_task IS   
  PRAGMA priority( zg_glob1.priority_2 );
  END simple_task ;

  type pointer_to_simple_task is access simple_task ;

end tk_lfpkg_58 ;

--------------------------------------------------------------------------------

--with zg_glob1;                         --+ tcl 6 April 1992, PCR #100, part 3
--with zg_glob2;                         --+ tcl 6 April 1992, PCR #100, part 3
--with zg_glob3;                         --+ tcl 6 April 1992, PCR #100, part 3
with zg_glob4;
package body tk_lfpkg_58 is

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

  TASK BODY simple_task IS
  BEGIN
    zg_glob4.proc0; 
  END simple_task ;

end tk_lfpkg_58 ;

--------------------------------------------------------------------------------

with zg_glob1;
use  zg_glob1;
with zg_glob2;
with zg_glob3;
with zg_glob4;
WITH calendar;
USE  calendar;
with tk_lfpkg_58 ; 
 
PROCEDURE tk_lf_task_58 IS
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

  task main IS   
  PRAGMA priority( zg_glob1.priority_1 );
  end main;

  task body main is
  begin
declare
  procedure create_elaborated_task is
    temp_task : tk_lfpkg_58.simple_task;
  BEGIN    -- start of tasking procedure
    zg_glob4.proc0; 
    while not temp_task'terminated  -- TEMP_TASK has higher priority
    loop
      null;
    end loop;
  END create_elaborated_task ;
begin

--------------------------------------------------------------------------------
  -- Test Name         :  TK_LF_TASK_58 
  -- Prime Purpose     :  This problem is one of a set which explores how task
  --                      creation time varies with the number of active tasks.
  --                      TK_LF_TASK_58 measures the time to create a task 
  --                      when there are no other active tasks running. The
  --                      task is created by elaborating a task declaration
  --                      in a declarative region and includes time to create
  --                      and terminate the task. 
  -- Optimization      :
  -- Related tests     :  TK_LS_TASK_59, TK_LS_TASK_68, and TK_LS_TASK_69
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  B. Decker-Lindsey - 28 February 1992
  -- Date              :  December 1991 
  -- Source            :  CECOM recommendation from "Final Report - Evaluation
  --                      of the ACEC Benchmark Suite for Real-Time 
  --                      Applications" July 1990
  -- Dependencies      :
  -- Other Information :
  -- Revisions         :  PCR #100
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Julie Leastman - 14 April 1992
  -- Changes           :  Removed WITH clauses for ZG_GLOB1, ZG_GLOB2 & 
  --                      ZG_GLOB3 from package body of tk_lfpkg_58 and moved
  --                      USE ZG_GLOB1 from package body of tk_lfpkg_58 to 
  --                      the package specification.
--------------------------------------------------------------------------------

  zg_glob2.put_test_name("tk_lf_task_58 ");
  PRAGMA include("startime");
    begin
      create_elaborated_task ;
    exception when others => null;
    end ;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
     "   Create a task with no tasks in background ");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
end; 

  end main ;

begin -- begining of main procedure 
      -- all the useful work has been done in tasks
  null;

end tk_lf_task_58 ;
