with zg_glob1;
use  zg_glob1;                    --+ tcl 6 April 1992, PCR #100 part 3
package tk_lfpkg_59 is

  TASK TYPE background_task IS   
  pragma priority( zg_glob1.priority_2 );
    entry stop_task; 
  END background_task;

  TASK TYPE simple_task IS   
  pragma priority( zg_glob1.priority_2 );
  END simple_task ;

  type pointer_to_simple_task is access simple_task ;
  type pointer_to_background_task is access background_task ;

end tk_lfpkg_59 ;

--------------------------------------------------------------------------------

--with zg_glob1;                    --+ tcl 6 April 1992, PCR #100 part 3
--use  zg_glob1;                    --+ tcl 6 April 1992, PCR #100 part 3
--with zg_glob2;                    --+ tcl 6 April 1992, PCR #100 part 3
--with zg_glob3;                    --+ tcl 6 April 1992, PCR #100 part 3
with zg_glob4;                    
package body tk_lfpkg_59 is

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

  TASK BODY background_task IS
  BEGIN
    zg_glob4.proc0;
    accept stop_task;
  END background_task ;

  TASK BODY simple_task IS
  BEGIN
    zg_glob4.proc0;
  END simple_task ;

end tk_lfpkg_59 ;

--------------------------------------------------------------------------------
with zg_glob1;
use  zg_glob1;
with zg_glob2;
with zg_glob3;
with zg_glob4;
WITH calendar;
USE  calendar;
with tk_lfpkg_59 ; 
 
PROCEDURE tk_lf_task_59 IS
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

  task main IS   
  pragma priority( zg_glob1.priority_1 );
  end main;

  task body main is
  begin
 
----------------------------------------------------------------------------


declare
  pointer_t1  : tk_lfpkg_59.pointer_to_background_task := 
                new tk_lfpkg_59.background_task ;
  pointer_t2  : tk_lfpkg_59.pointer_to_background_task := new 
                tk_lfpkg_59.background_task ;
  pointer_t3  : tk_lfpkg_59.pointer_to_background_task := new 
                tk_lfpkg_59.background_task ;
  pointer_t4  : tk_lfpkg_59.pointer_to_background_task := new 
                tk_lfpkg_59.background_task ;
  pointer_t5  : tk_lfpkg_59.pointer_to_background_task := new 
                tk_lfpkg_59.background_task ;
  pointer_t6  : tk_lfpkg_59.pointer_to_background_task := new 
                tk_lfpkg_59.background_task ;
  pointer_t7  : tk_lfpkg_59.pointer_to_background_task := new 
                tk_lfpkg_59.background_task ;
  pointer_t8  : tk_lfpkg_59.pointer_to_background_task := new 
                tk_lfpkg_59.background_task ;
  pointer_t9  : tk_lfpkg_59.pointer_to_background_task := new 
                tk_lfpkg_59.background_task ;
  pointer_t10 : tk_lfpkg_59.pointer_to_background_task := new 
                tk_lfpkg_59.background_task ;

    procedure create_dynamic_task is
      temp_task : tk_lfpkg_59.pointer_to_simple_task := new 
                  tk_lfpkg_59.simple_task ;
    BEGIN    -- start of tasking procedure
      zg_glob4.proc0; 
      while not temp_task'terminated  -- TEMP_TASK has higher priority
      loop
        null;
      end loop;
    END create_dynamic_task ; 
 
begin

--------------------------------------------------------------------------------
  -- Test Name         :  TK_LF_TASK_59 
  -- Prime Purpose     :  This problem is one of a set which explores how task
  --                      creation time varies with the number of active tasks.
  --                      TK_LF_TASK_59 measures the time to create a task 
  --                      when there are ten other active tasks running, created
  --                      by executing allocators. The task being measured 
  --                      is created by executing an allocator and the time 
  --                      includes creating and terminating the task. 
  -- Optimization      :
  -- Related tests     :  TK_LS_TASK_58, TK_LS_TASK_68, and TK_LS_TASK_69
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  B. Decker-Lindsey - 28 February 1992
  -- Date              :  December 1991 
  -- Source            :  CECOM recommendation from "Final Report - Evaluation
  --                      of the ACEC Benchmark Suite for Real-Time
  --                      Applications" July 1990
  -- Dependencies      :
  -- Other Information :
  -- Revisions         :  PCR #100
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Julie Leastman - 14 April 1992
  -- Date              :  6 April 1992
  -- Changes           :  Removed unneeded WITH clauses from package body 
  --                      tk_lfpkg_59 and moved USE ZG_GLOB1 clause to package
  --                      specification of tk_lfpkg_59.  
--------------------------------------------------------------------------------

  zg_glob2.put_test_name("tk_lf_task_59 ");
  PRAGMA include("startime");
    begin
      create_dynamic_task ; 
    exception when others => null;
    end ;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
     "   Create a task with ten tasks in background created ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
     "   by executing allocators. ");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  pointer_t1 .stop_task;
  pointer_t2 .stop_task;
  pointer_t3 .stop_task;
  pointer_t4 .stop_task;
  pointer_t5 .stop_task;
  pointer_t6 .stop_task;
  pointer_t7 .stop_task;
  pointer_t8 .stop_task;
  pointer_t9 .stop_task;
  pointer_t10.stop_task;
end; 
  
  end main ;

begin -- beginning of main procedure 
      -- all the useful work has been done in tasks
  null;
END tk_lf_task_59 ;
