with zg_glob1;
use  zg_glob1;
--with zg_glob2;                  --+ tcl 7 April 1992, PCR #100 part 3
--with zg_glob3;                  --+ tcl 7 April 1992, PCR #100 part 3
--with zg_glob4;                  --+ tcl 7 April 1992, PCR #100 part 3
--with system;                    --+ tcl 7 April 1992, PCR #100 part 3
                                  --+    A "WITH SYSTEM;" may be necessary on
                                  --+    some compilers to use PRAGMA PRIORITY
                                  --+    even though Ada Interpretation
                                  --+    AI-00197 clearly states that it should
                                  --+    NOT be required.

package tk_lfpkg_63 is

  task type child is
    pragma priority( zg_glob1.priority_1 );
    entry STOP_PROBLEM;
  end child ;

  task type parent is
    pragma priority( zg_glob1.priority_1 );
  end parent ;

  type caller is ( was_parent, was_child, was_grand_parent );

  last_caller : caller; 
  save_last_caller : caller; 
  pragma shared ( last_caller ); 
  pragma shared ( save_last_caller ); 

end tk_lfpkg_63 ;

--------------------------------------------------------------------------------

package body tk_lfpkg_63 is

  pragma SUPPRESS (ACCESS_CHECK);
  pragma SUPPRESS (DISCRIMINANT_CHECK);
  pragma SUPPRESS (INDEX_CHECK);
  pragma SUPPRESS (LENGTH_CHECK);
  pragma SUPPRESS (RANGE_CHECK);
  pragma SUPPRESS (DIVISION_CHECK);
  pragma SUPPRESS (OVERFLOW_CHECK);
  pragma SUPPRESS (ELABORATION_CHECK);
  pragma SUPPRESS (STORAGE_CHECK);

  function function_with_side_effect_of_setting_last_caller_to_parent 
     return caller is
  begin
    last_caller := was_parent;
    return was_parent;
  end function_with_side_effect_of_setting_last_caller_to_parent ;

  task body child is
  begin
    last_caller := was_child;
    accept STOP_PROBLEM;
  end child ;

  task body parent is
    temp_kludge : caller := 
      function_with_side_effect_of_setting_last_caller_to_parent;
    child_task : child;
  begin
    save_last_caller := last_caller ;
    child_task.stop_problem;    
  end parent ;

end tk_lfpkg_63 ;

--------------------------------------------------------------------------------

with zg_glob1;
use  zg_glob1;
with zg_glob2;
with zg_glob3;
with zg_glob4;
with calendar;
use  calendar;
--with system;                    --+ tcl 7 April 1992, PCR #100 part 3
                                  --+    A "WITH SYSTEM;" may be necessary on
                                  --+    some compilers to use PRAGMA PRIORITY
                                  --+    even though Ada Interpretation
                                  --+    AI-00197 clearly states that it should
                                  --+    NOT be required.
with tk_lfpkg_63 ;

procedure tk_lf_task_63 is

  pragma SUPPRESS (ACCESS_CHECK);
  pragma SUPPRESS (DISCRIMINANT_CHECK);
  pragma SUPPRESS (INDEX_CHECK);
  pragma SUPPRESS (LENGTH_CHECK);
  pragma SUPPRESS (RANGE_CHECK);
  pragma SUPPRESS (DIVISION_CHECK);
  pragma SUPPRESS (OVERFLOW_CHECK);
  pragma SUPPRESS (ELABORATION_CHECK);
  pragma SUPPRESS (STORAGE_CHECK);

  begin

--------------------------------------------------------------------------------
  -- Test Name         :  TK_LF_TASK_63
  -- Prime Purpose     :  This test problem will determine whether, when a 
  --                      task of equal priority to its master is activated, 
  --                      the created task or the master is scheduled for 
  --                      execution first.
  -- Optimization      :  
  -- Related tests     :  
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  B. Decker-Lindsey  - 2 March 1992
  -- Date              :  December 1991
  -- Source            :  CECOM recommendation from "Final Report - Evaluation
  --                      of the ACEC Benchmark Suite for Real-Time
  --                      Applications" July 1990
  -- Dependencies      :
  -- Other Information :
  -- Revisions         :  PCR #100
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Julie Leastman - 14 April 1992
  -- Date              :  7 April 1992
  -- Changes           :  Commented out reference to WITH SYSTEM with comments 
  --                      stating that some systems may require it to use a 
  --                      PRAGMA PRIORITY directive and removed unnecessary
  --                      WITH clauses on package for ZG_GLOB2, ZG_GLOB3 and 
  --                      ZG_GLOB4. Corrected spelling in output of ancillary
  --                      data, replaced "discrepency" with "discrepancy."
-------------------------------------------------------------------------------

    zg_glob2.put_test_name("tk_lf_task_63 ");
    pragma INCLUDE ("startime");
      tk_lfpkg_63.save_last_caller := tk_lfpkg_63.was_grand_parent;
      declare 
        temp_task : tk_lfpkg_63.parent ;
      begin
        zg_glob4.proc0;
      end;
    pragma INCLUDE ("stoptime0");
    zg_glob2.put_comment_optional(
      "   Determine whether the created or the creating ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional(
      "   task is scheduled for execution first.");
    zg_glob2.put_new_line_optional;
    pragma INCLUDE ("stoptime2");
    ----------------------------------------------------------------------------

    case tk_lfpkg_63.save_last_caller is 
    when tk_lfpkg_63.was_child        => 
      zg_glob2.put_ancillary(
        " >>> TK_LF_TASK_63 created task executed first ");
      zg_glob2.put_new_line;
    when tk_lfpkg_63.was_parent       => 
      zg_glob2.put_ancillary(
        " >>> TK_LF_TASK_63 creating task executed first ");
      zg_glob2.put_new_line;
    when tk_lfpkg_63.was_grand_parent => 
      zg_glob2.put_ancillary(
                --+ tcl 7 April 1992, PCR #100 part 4
                --      corrected typo, replaced "discrepency" with 
                --      "discrepancy"
        " >>> TK_LF_TASK_63 internal discrepancy "); -- should not happen
      zg_glob2.put_new_line;
    end case;

end tk_lf_task_63 ;
