with zg_glob1;
use  zg_glob1;
--with zg_glob2;                  --+ tcl 7 April 1992, PCR #100 part 3
--with zg_glob3;                  --+ tcl 7 April 1992, PCR #100 part 3
with zg_glob4;
--with system;                    --+ tcl 7 April 1992, PCR #100 part 3
                                  --+    A "WITH SYSTEM;" may be necessary on
                                  --+    some compilers to use PRAGMA PRIORITY
                                  --+    even though Ada Interpretation
                                  --+    AI-00197 clearly states that it should
                                  --+    NOT be required.

package tk_lfpkg_68 is

  TASK TYPE background_task IS   
    pragma priority( zg_glob1.priority_2 );
    entry stop_task; 
  END background_task;

  TASK TYPE simple_task IS   
    pragma priority( zg_glob1.priority_2 );
  END simple_task ;

  t1  : background_task ;
  t2  : background_task ;
  t3  : background_task ;
  t4  : background_task ;
  t5  : background_task ;
  t6  : background_task ;
  t7  : background_task ;
  t8  : background_task ;
  t9  : background_task ;
  t10 : background_task ;

end tk_lfpkg_68 ;

--------------------------------------------------------------------------------

package body tk_lfpkg_68 is


  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

  TASK BODY background_task IS
  BEGIN
    zg_glob4.proc0; 
    accept stop_task;
  END background_task ;
 
  TASK BODY simple_task IS
  BEGIN
    zg_glob4.proc0; 
  END simple_task ;

end tk_lfpkg_68 ;

--------------------------------------------------------------------------------

with zg_glob1;
use  zg_glob1;
with zg_glob2;                                  
with zg_glob3;
with zg_glob4;
with calendar;
use  calendar;
--with system;                    --+ tcl 7 April 1992, PCR #100 part 3
                                  --+    A "WITH SYSTEM;" may be necessary on
                                  --+    some compilers to use PRAGMA PRIORITY
                                  --+    even though Ada Interpretation
                                  --+    AI-00197 clearly states that it should
                                  --+    NOT be required.
with tk_lfpkg_68 ; 
 
PROCEDURE tk_lf_task_68 IS

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

  task main IS   
    pragma priority( zg_glob1.priority_1 );
  end main;

  task body main is
  begin
 
  declare
    procedure create_dynamic_task is
      temp_task : tk_lfpkg_68.simple_task ;
    BEGIN    -- start of tasking procedure
      zg_glob4.proc0; 
      while not temp_task'terminated  -- TEMP_TASK has higher priority
      loop
        null;
      end loop;
    END create_dynamic_task ; 
 
  begin

--------------------------------------------------------------------------------
  -- Test Name         :  TK_LF_TASK_68 
  -- Prime Purpose     :  This problem is one of a set which explores how task
  --                      creation time varies with the number of active tasks.
  --                      TK_LF_TASK_68 measures the time to create a task 
  --                      when there are ten other active tasks running, created
  --                      by elaborating task declarations in a package 
  --                      specification. The library tasks could be 
  --                      preelaborated. The task being measured is created 
  --                      by executing an allocator and the time includes 
  --                      creating and terminating the task. 
  -- Optimization      :
  -- Related tests     :  TK_LS_TASK_58, TK_LS_TASK_59, and TK_LS_TASK_69
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  B. Decker-Lindsey  - 2 March 1992
  -- Date              :  December 1991
  -- Source            :  CECOM recommendation from "Final Report - Evaluation
  --                      of the ACEC Benchmark Suite for Real-Time 
  --                      Applications" July 1990
  -- Dependencies      :
  -- Other Information :
  -- Revisions         :  PCR #100
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Julie Leastman - 14 April 1992
  -- Date              :  7 April 1992
  -- Changes           :  Commented out reference to WITH SYSTEM with comments 
  --                      stating that some systems may require it to use a 
  --                      PRAGMA PRIORITY directive. Also removed unneeded 
  --                      WITH clauses for ZG_GLOB2 and ZG_GLOB3 from
  --                      package context clause.
--------------------------------------------------------------------------------

  zg_glob2.put_test_name("tk_lf_task_68 ");
  PRAGMA include("startime");
    begin
      create_dynamic_task ; 
    exception when others => null;
    end ;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
    "   Create a task by elaborating declaration when there are ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
    "   ten tasks in background created by elaborating declarations ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
    "   in a library specification (which could be preelaborated). ");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  tk_lfpkg_68.t1 .stop_task;
  tk_lfpkg_68.t2 .stop_task;
  tk_lfpkg_68.t3 .stop_task;
  tk_lfpkg_68.t4 .stop_task;
  tk_lfpkg_68.t5 .stop_task;
  tk_lfpkg_68.t6 .stop_task;
  tk_lfpkg_68.t7 .stop_task;
  tk_lfpkg_68.t8 .stop_task;
  tk_lfpkg_68.t9 .stop_task;
  tk_lfpkg_68.t10.stop_task;
  end; 
  
  end main ;

begin -- begining of main procedure 
      -- all the useful work has been done in tasks
  null;
END tk_lf_task_68 ;
