with TEXT_IO;

package tk_lfpkg76a is
   outputFile    : text_io.FILE_TYPE;
   procedure PKG_TASK_STARTUP;
end tk_lfpkg76a;

package body tk_lfpkg76a is

task PKG_TASK is
   entry STARTUP;
end PKG_TASK;

task body PKG_TASK is
begin
   accept STARTUP;
   delay 10.0;
    -- Overwrite temp.txt written to by main program 
   text_io.OPEN (outputFile, text_io.OUT_FILE, "temp.txt");
   text_io.PUT(outputFile, "LIB_TASK_ENDS_WHEN_MAIN_ENDS := FALSE;");
   text_io.CLOSE (outputFile);
end PKG_TASK;

procedure PKG_TASK_STARTUP is

begin
   PKG_TASK.STARTUP;
end PKG_TASK_STARTUP;

end tk_lfpkg76a;

-------------------------------------------------------------------------------

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
WITH zg_glob3;
WITH zg_glob4;
WITH calendar; 
USE  calendar;
WITH text_io;
WITH tk_lfpkg76a;

  --
  -- Test Name         : tk_lf_task_76
  -- Prime Purpose     : This program tests whether tasks that depend on a 
  --                     library package are required to terminate when the 
  --                     main program terminates.
  -- Optimization      :
  -- Related tests     :  
  -- Author            : Julie Leastman
  -- Reviewer          : Thomas C. Leavitt, 30 March 1992
  -- Date              : March 12, 1992 
  -- Source            : AES Test TR01
  -- Dependencies      :
  -- Other Information : 
  -- 


procedure tk_lf_task_76 is

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

begin
  zg_glob2.put_test_name("tk_lf_task_76");

  pragma include("startime");
    zg_glob4.PROC0;
  pragma include ("stoptime0");

  zg_glob2.put_comment_optional(
  "   This program tests whether tasks that depend on a library ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   package are required to terminate when the main program terminates. ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   Ancillary data is the important output for this test problem. ");
  zg_glob2.put_new_line_optional;

  pragma include ("stoptime2");

  text_io.CREATE (tk_lfpkg76a.outputFile, text_io.OUT_FILE, "temp.txt");
  text_io.PUT (tk_lfpkg76a.outputFile, 
               "LIB_TASK_ENDS_WHEN_MAIN_ENDS := TRUE ;");
  text_io.CLOSE (tk_lfpkg76a.outputFile);

  tk_lfpkg76a.PKG_TASK_STARTUP;

   -- temp.txt is created with the assumption that the library task in
   -- tk_lfpkg76a will be terminated on exit from this the main procedure.
   -- temp.txt will be overwritten by the execution of the library task if
   -- it is not terminated.
end tk_lf_task_76;

-----------------------------------------------------------------------------

WITH TEXT_IO; 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;

procedure tk_lf37R is

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

  lineLength         : Natural         := 38;
  SUBTYPE aline IS string ( 1 .. lineLength );
  line               : aline;
  inputFile          : text_io.FILE_TYPE;

BEGIN

-- This program reads the temp.txt created by test problem tk_lf_task_76 
-- and provides ancillary data.  tk_lf_task_76 tests whether tasks that depend
-- on a library package are required to terminate when the main program 
-- terminates, and the data in temp.txt allows the user to make that
-- determination.

  text_io.OPEN (inputFile, text_io.IN_FILE, "temp.txt");
  text_io.GET_LINE (inputFile, line, lineLength); 
  text_io.CLOSE (inputFile);

  IF line(33..lineLength) = "TRUE ;"
  THEN
    zg_glob2.put_ancillary( 
" >>> tk_lf_task_76 This compilation system terminates library tasks when ");
    zg_glob2.put_new_line;
    zg_glob2.put_ancillary (
" >>> tk_lf_task_76 the main procedure completes." );
    zg_glob2.put_new_line;
  ELSE
    zg_glob2.put_ancillary ( 
" >>> tk_lf_task_76 This compilation system does NOT terminate library tasks");
    zg_glob2.put_new_line;
    zg_glob2.put_ancillary (
" >>> tk_lf_task_76 just because the main procedure completes." );
    zg_glob2.put_new_line;
  END IF;

    zg_glob2.put_comment (
       "\ACES end   mainprogram\ ******************** tk_lfm37 " ) ;
    zg_glob2.put_new_line;

EXCEPTION
    WHEN OTHERS =>
        zg_glob2.put_comment (
           "\ACES end   mainprogram\ ******************** tk_lfm37 " ) ;
        zg_glob2.put_new_line;
END tk_lf37R;

