WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
WITH zg_glob3;
WITH zg_glob4;

WITH calendar;
USE  calendar;
 
PROCEDURE tk_lf_task_86 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
      PRAGMA priority( zg_glob1.priority_1 );
  END main;
 
  TASK resource IS
      PRAGMA priority( zg_glob1.priority_2 );
    ENTRY request;
    ENTRY release;
  END resource;
 
  TASK BODY resource IS
  BEGIN
    LOOP
      ACCEPT request;
      ACCEPT release;
    END LOOP;
  END resource;
 
  TASK BODY main IS
  BEGIN
 
 
    --
    -- Test Name         :  tk_lf_task_86
    -- Prime Purpose     :  language feature test of aspects of tasking. 
    --                      Simple rendezvous using timed entry calls: task
    --                      doing accept arrives at rendezvous first.
    -- Optimization      :
    -- Related tests     :  tk_lf_task_23
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Julie Leastman 8/25/92
    -- Date              :  8 June 1992
    -- Source            :  AES Test TL16, which measured conditional entry 
    --                      calls, while this problem measures timed entry calls
    -- Dependencies      :  
    -- Other Information :
    --
  
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_lf_task_86");

    PRAGMA include("startime");

    FOR i IN 1 .. 10 LOOP
                      -- if either DELAY alternative is taken, the problem will
                      -- fail by raising PROGRAM_ERROR (within DIE)
      SELECT resource.request; OR DELAY 0.100; zg_glob4.die; END SELECT;
      SELECT resource.release; OR DELAY 0.100; zg_glob4.die; END SELECT;
    END LOOP;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional(
      "   Timed entry calls which should be processed immediately. ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   FOR i IN 1..10");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional(
  "      SELECT resource.request; OR DELAY 0.100; zg_glob4.die; END SELECT;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional(
  "      SELECT resource.release; OR DELAY 0.100; zg_glob4.die; END SELECT;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END LOOP;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- priorities ensure task doing accept");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- will arrive at rendezvous first");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- compare with tk_lf_task_23");

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
    zg_glob2.put_ancillary(" >>> tk_lf_task_86 time per rendezvous = ");
    zg_glob2.put_value( (zg_glob3.min_time * 1000000.0 / 20.0), 8, 1, 0);
    zg_glob2.put_new_line;
 
    ABORT resource;    -- stop execution
  END main;
 
BEGIN
  NULL;
END tk_lf_task_86;

--------------------------------------------------------------------------------
