-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- tk_ls_task_05 conditional selects
-- example from LRM 9.7.1

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH system;
 
PROCEDURE tk_ls_task_05 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END main;
 
  TASK TYPE resource IS 
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
  ENTRY seize;
  ENTRY release;
END resource;
 
r      : resource;
 
TASK BODY resource IS
  busy : boolean := false;
BEGIN
  LOOP
    SELECT
      WHEN NOT busy =>
        ACCEPT seize DO
          busy := true;
        END seize;
    OR
      ACCEPT release DO
        busy := false;
      END release;
    OR
      TERMINATE;
    END SELECT;
  END LOOP;
END resource;
 
PROCEDURE spin(r : resource) IS    -- from LRM 9.7.2
BEGIN
 
 
  --
  -- Test Name         :  tk_ls_task_05
  -- Prime Purpose     :  Language feature test of aspects of tasking.  Always
  --                      takes ELSE alternative.
  -- LRM Version       :  A
  -- Optimization      :
  -- Related Tests     :  tk_ls_task_32
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :
  -- Source            :  Example from LRM 9.7.1.
  --                      Conditional entry call from LRM 9.7.2.
  -- Dependencies      :
  -- Other Information :
  --
  
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("tk_ls_task_05");

  PRAGMA include("startime");

  SELECT                           -- should never succeed
    r.seize;
    RAISE program_error;
  ELSE
    NULL;
  END SELECT;

  PRAGMA include("stoptime0");

  zg_glob2.put_comment_optional
       ("   conditional entry call, tasks in same unit, compare tk_ls_task_32");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   SELECT     -- should never succeed");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("     r.seize;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("     raise program_error;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   ELSE");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("     NULL;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("   END SELECT;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("  -- selecting task contains");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("  LOOP");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      SELECT");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("        WHEN NOT busy=>");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("          ACCEPT seize DO");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("            busy := true;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("          END;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("        OR");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("          ACCEPT release DO");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("            busy := false;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("          END;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("        OR ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("          TERMINATE;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("      END SELECT;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional("    END LOOP;");

  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
 
END spin;
 
TASK BODY main IS
BEGIN
  r.seize;
  spin(r);
  ABORT r;           -- clean up
END main;
 
BEGIN
  NULL;
END tk_ls_task_05;
