-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- tk_ls_task_18
--  This is an example of conditional selects with all alternatives closed 
--  and entry calls waiting on all alternatives 

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;

with CALENDAR;
use CALENDAR;
with SYSTEM;

procedure tk_ls_task_18 is

  pragma SUPPRESS (ACCESS_CHECK);
  pragma SUPPRESS (DISCRIMINANT_CHECK);
  pragma SUPPRESS (INDEX_CHECK);
  pragma SUPPRESS (LENGTH_CHECK);
  pragma SUPPRESS (RANGE_CHECK);
  pragma SUPPRESS (DIVISION_CHECK);
  pragma SUPPRESS (OVERFLOW_CHECK);
  pragma SUPPRESS (ELABORATION_CHECK);
  pragma SUPPRESS (STORAGE_CHECK);

  task SIMPLE_TASK is
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
    entry ENTRY1;
    entry ENTRY2;
    entry ENTRY3;
    entry ENTRY4;
    entry ENTRY5;
  end SIMPLE_TASK;

  task T1 is
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  end T1;

  task body T1 is
  begin
    loop
      SIMPLE_TASK.ENTRY1;
      zg_glob4.ii := 1;
      zg_glob4.proc0;
    end loop;
  end T1;

  task T2 is
      --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  end T2;

  task body T2 is
  begin
    loop
      SIMPLE_TASK.ENTRY2;
      zg_glob4.ii := 2;
      zg_glob4.proc0;
    end loop;
  end T2;

  task T3 is
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  end T3;

  task body T3 is
  begin
    loop
      SIMPLE_TASK.ENTRY3;
      zg_glob4.ii := 3;
      zg_glob4.proc0;
    end loop;
  end T3;

  task T4 is
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  end T4;

  task body T4 is
  begin
    loop
      SIMPLE_TASK.ENTRY4;
      zg_glob4.ii := 4;
      zg_glob4.proc0;
    end loop;
  end T4;

  task T5 is
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  end T5;

  task body T5 is
  begin
    loop
      SIMPLE_TASK.ENTRY5;
      zg_glob4.ii := 5;
      zg_glob4.proc0;
    end loop;
  end T5;

  task body SIMPLE_TASK is
  begin

    zg_glob1.bool := FALSE;

    --
    -- Test Name         :  tk_ls_task_18
    -- Prime Purpose     :  Language feature test of aspects of tasking.  
    --                      Accepting task contains a conditional select 
    --                      statements with WHEN clauses, none of which is 
    --                      satisfied. Tasks waiting at all entries.  Selected 
    --                      alternative is ELSE. This test measures the time 
    --                      to test alternatives should be fairly fast.
    -- LRM Version       :  A
    -- Optimization      :  
    -- Related tests     :  
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :  
    -- Source            :  
    -- Dependencies      :  
    -- Other Information :  
    --

    ----------------------------------------------------------------------------
    zg_glob2.put_test_name ("tk_ls_task_18");

    pragma INCLUDE ("startime");

    select
      when zg_glob1.bool =>
        accept ENTRY1 do
          zg_glob4.ii := 2;
          zg_glob4.proc0;
        end ENTRY1;
    or
      when zg_glob1.bool =>
        accept ENTRY2 do
          zg_glob4.ii := 3;
          zg_glob4.proc0;
        end ENTRY2;
    or
      when zg_glob1.bool =>
        accept ENTRY3 do
          zg_glob4.ii := 4;
          zg_glob4.proc0;
        end ENTRY3;
    or
      when zg_glob1.bool =>
        accept ENTRY4 do
          zg_glob4.ii := 5;
          zg_glob4.proc0;
        end ENTRY4;
    or
      when zg_glob1.bool =>
        accept ENTRY5 do
          zg_glob4.ii := 1;
          zg_glob4.proc0;
        end ENTRY5;
    else
      zg_glob4.proc0; -- selected alternative
             --      
    end select;

    pragma INCLUDE ("stoptime0");

    zg_glob2.put_comment_optional 
	("   conditional select with no open alternatives,");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional 
	("  -- ('bool' is false) and tasks waiting on all entries");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional ("   SELECT");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional ("       WHEN bool =>");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional 
	("         ACCEPT entry1 DO ii :=  2;  proc0;  END entry1;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional ("   OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional ("       WHEN bool =>");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional 
	("         ACCEPT entry2 DO ii :=  3;  proc0;  END entry2;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional ("   OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional ("       WHEN bool =>");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional 
	("         ACCEPT entry3 DO ii :=  4;  proc0;  END entry3;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional ("   OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional ("       WHEN bool =>");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional 
	("         ACCEPT entry4 DO ii :=  5;  proc0;  END entry4;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional ("   OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional ("       WHEN bool =>");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional 
	("         ACCEPT entry5 DO ii :=  1;  proc0;  END entry5;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional ("   ELSE");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional ("       proc0; -- selected alternative");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional ("   END SELECT;");
    zg_glob2.put_new_line_optional;

    pragma INCLUDE ("stoptime2");
    ----------------------------------------------------------------------------

    abort T1, T2, T3, T4, T5;
  end SIMPLE_TASK;

begin
  null; -- will terminate when task enclosed in it terminates
end tk_ls_task_18;
