-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- +++ tcl 2-8-89 change to make ancillary information self-identifying
-- tk_ls_task_27
WITH zg_glob1;
 
PACKAGE pkg01_tk_ls12 IS
  TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    ENTRY request;
    ENTRY release;
  END resource;
END pkg01_tk_ls12;
 
PACKAGE BODY pkg01_tk_ls12 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK BODY resource IS
  BEGIN
    LOOP
      SELECT
        ACCEPT request;
      END SELECT;
      SELECT
        ACCEPT release;
      END SELECT;
    END LOOP;
  END resource;
END pkg01_tk_ls12;
 
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH pkg01_tk_ls12;
USE  pkg01_tk_ls12;
WITH system;
 
PROCEDURE tk_ls_task_27 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
  END main;
 
 
  TASK BODY main IS
  BEGIN
 
    --
    -- Test Name         :  tk_ls_task_27
    -- Prime Purpose     :  Language feature test of aspects of tasking.
    --                      Rendezvous with the task making an entry call
    --                      arriving at rendezvous first.  Brackets each ACCEPT
    --                      with a SELECT/END pair.
    -- LRM Version       :  A
    -- Optimization      :  Redundant code elimination -
    --                      Select with one unconditional accept can be treated
    --                      as a simple accept.
    -- Related tests     :  tk_lf_task_26
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
  
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_ls_task_27");

    PRAGMA include("startime");

    FOR i IN 1 .. 10 LOOP
      resource.request;
      resource.release;
    END LOOP;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   FOR i IN 1..10 ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      resource.request;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      resource.release;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END LOOP;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- priorities are such that task making entry ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- call will arrive at rendezvous first");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- package resource  contains");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --   LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --      SELECT ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --         ACCEPT request;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --      END SELECT;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --      SELECT");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --         ACCEPT release;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --      END SELECT;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --   END LOOP;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- can be optimized into same as tk_lf_task_26");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
		----------------------------------------------------
		-- +++ tcl 2-8-89 make ancillary information self-identifying
    zg_glob2.put_ancillary(" >>> tk_ls_task_27 Time per rendezvous = ");
    zg_glob2.put_value ( (zg_glob3.min_time * 1_000_000.0 / 20.0), 8, 1, 0);
    zg_glob2.put_new_line;
                ----------------------------------------------------
 
    ABORT resource;    -- stop execution
  END main;
 
BEGIN
  NULL;
END tk_ls_task_27;
