-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- +++ tcl 2-8-89 change to make ancillary information self-identifying
-- tk_ls_task_28
WITH zg_glob1;
 
PACKAGE pkg01_tk_ls13 IS
  TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    ENTRY request;
    ENTRY release;
  END resource;
END pkg01_tk_ls13;
 
PACKAGE BODY pkg01_tk_ls13 IS
 
  TASK BODY resource IS
    PRAGMA suppress(access_check);
    PRAGMA suppress(discriminant_check);
    PRAGMA suppress(index_check);
    PRAGMA suppress(length_check);
    PRAGMA suppress(range_check);
    PRAGMA suppress(division_check);
    PRAGMA suppress(overflow_check);
    PRAGMA suppress(elaboration_check);
    PRAGMA suppress(storage_check);
 
  BEGIN
    LOOP
      SELECT    -- can be folded, simplified
        WHEN true =>
          ACCEPT request;
      OR
        WHEN false =>
          ACCEPT release;
      END SELECT;
      SELECT
        WHEN false =>
          ACCEPT request;
      OR
        WHEN true =>
          ACCEPT release;
      END SELECT;
    END LOOP;
  END resource;
END pkg01_tk_ls13;
 
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH pkg01_tk_ls13;
USE  pkg01_tk_ls13;
WITH system;
 
PROCEDURE tk_ls_task_28 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
  END main;
 
 
  TASK BODY main IS
  BEGIN
 
 
    --
    -- Test Name         :  tk_ls_task_28
    -- Prime Purpose     :  Language feature test of aspects of tasking.
    --                      Rendezvous with the task making an ENTRY call
    --                      arriving first.  Brackets each ACCEPT with a SELECT/
    --                      END pair containing WHEN clauses which can be
    --                      evaluated at compile time.
    -- LRM Version       :  A
    -- Optimization      :  Folding of WHEN clause conditions.
    -- Related tests     :  tk_lf_task_26, tk_ls_task_27
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
 
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_ls_task_28");

    PRAGMA include("startime");

    FOR i IN 1 .. 10 LOOP
      resource.request;
      resource.release;
    END LOOP;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   FOR i IN 1..10 ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      resource.request;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      resource.release;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END LOOP;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- priorities are such that task making entry call will");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- arrive at rendezvous first");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- same as tk_lf_task_03 with ""resource"" in separate package");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- here resource has accepts in clause");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --    SELECT  ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --       WHEN true  => ACCEPT request;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --    OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --       WHEN false => ACCEPT release;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --    END SELECT;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --    SELECT");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --       WHEN false => ACCEPT request;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --    OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --       WHEN true  => ACCEPT release;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --    END SELECT;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- END LOOP;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- can be folded and simplified as tk_ls_task_27 & tk_lf_task_26");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
		----------------------------------------------------
		-- +++ tcl 2-8-89 make ancillary information self-identifying
    zg_glob2.put_ancillary(" >>> tk_ls_task_28 time per rendezvous = ");
    zg_glob2.put_value( (zg_glob3.min_time * 1_000_000.0 / 20.0), 8, 1, 0);
    zg_glob2.put_new_line;
                ----------------------------------------------------
 
    ABORT resource;    -- stop execution
  END main;
 
BEGIN
  NULL;
END tk_ls_task_28;
