-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities

-- +++ tcl 2-8-89 change to make ancillary information self-identifying
-- tk_ls_task_29

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;

WITH system;
 
PACKAGE pkg01_tk_ls14 IS
  TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    ENTRY request;
    ENTRY release;
  END resource;
END pkg01_tk_ls14;
 
PACKAGE BODY pkg01_tk_ls14 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK BODY resource IS
  BEGIN
    LOOP
      SELECT    -- can be folded, simplified
        WHEN 1 = 5 =>
          ACCEPT request DO
            zg_glob4.ii := 1;
          END request;
      OR
        WHEN 2 = 5 =>
          ACCEPT request DO
            zg_glob4.ii := 2;
          END request;
      OR
        WHEN 3 = 5 =>
          ACCEPT request DO
            zg_glob4.ii := 3;
          END request;
      OR
        WHEN 4 = 5 =>
          ACCEPT request DO
            zg_glob4.ii := 4;
          END request;
      OR
        WHEN 5 = 5 =>
          ACCEPT request DO
            zg_glob4.ii := 5;
          END request;
      OR
        WHEN 6 = 5 =>
          ACCEPT request DO
            zg_glob4.ii := 6;
          END request;
      OR
        WHEN 7 = 5 =>
          ACCEPT request DO
            zg_glob4.ii := 7;
          END request;
      OR
        WHEN 8 = 5 =>
          ACCEPT request DO
            zg_glob4.ii := 8;
          END request;
      OR
        WHEN 9 = 5 =>
          ACCEPT request DO
            zg_glob4.ii := 9;
          END request;
      END SELECT;
      SELECT
        WHEN 1 = 5 =>
          ACCEPT release DO
            zg_glob4.ii := 1;
          END release;
      OR
        WHEN 2 = 5 =>
          ACCEPT release DO
            zg_glob4.ii := 2;
          END release;
      OR
        WHEN 3 = 5 =>
          ACCEPT release DO
            zg_glob4.ii := 3;
          END release;
      OR
        WHEN 4 = 5 =>
          ACCEPT release DO
            zg_glob4.ii := 4;
          END release;
      OR
        WHEN 5 = 5 =>
          ACCEPT release DO
            zg_glob4.ii := 5;
          END release;
      OR
        WHEN 6 = 5 =>
          ACCEPT release DO
            zg_glob4.ii := 6;
          END release;
      OR
        WHEN 7 = 5 =>
          ACCEPT release DO
            zg_glob4.ii := 7;
          END release;
      OR
        WHEN 8 = 5 =>
          ACCEPT release DO
            zg_glob4.ii := 8;
          END release;
      OR
        WHEN 9 = 5 =>
          ACCEPT release DO
            zg_glob4.ii := 9;
          END release;
      END SELECT;
    END LOOP;
  END resource;
END pkg01_tk_ls14;
 
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;

WITH calendar;
USE  calendar;
WITH pkg01_tk_ls14;
USE  pkg01_tk_ls14;
WITH system;
 
PROCEDURE tk_ls_task_29 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
  END main;
 
  TASK BODY main IS
  BEGIN
 
 
    --
    -- Test Name         :  tk_ls_task_29
    -- Prime Purpose     :  Language feature test of aspects of tasking.
    --                      Rendezvous with the task making an ENTRY call
    --                      arriving at the rendezvous first.  Brackets each
    --                      ACCEPT with a SELECT/END pair containing WHEN
    --                      clauses which can be evaluated at compile time.
    -- LRM Version       :  A
    -- Optimization      :  Folding of WHEN clause conditions.
    -- Related tests     :
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
 
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_ls_task_29");

    PRAGMA include("startime");

    FOR i IN 1 .. 10 LOOP
      resource.request;
      resource.release;
    END LOOP;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   FOR i IN 1..10 ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      resource.request;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      resource.release;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END LOOP;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- priorities are such that task making entry call will");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- arrive at rendezvous first");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- same as tk_lf_task_03 with ""resource"" in separate package");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- here resource has accepts in conditional select ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --   SELECT-- can be folded, simplified");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --        WHEN 1 = 5  => ACCEPT request DO ii := 1; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 2 = 5  => ACCEPT request DO ii := 2; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 3 = 5  => ACCEPT request DO ii := 3; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 4 = 5  => ACCEPT request DO ii := 4; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 5 = 5  => ACCEPT request DO ii := 5; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 6 = 5  => ACCEPT request DO ii := 6; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 7 = 5  => ACCEPT request DO ii := 7; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 8 = 5  => ACCEPT request DO ii := 8; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 9 = 5  => ACCEPT request DO ii := 9; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --     END SELECT;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --     SELECT");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --        WHEN 1 = 5  => ACCEPT DO ii := 1; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 2 = 5  => ACCEPT release DO ii := 2; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 3 = 5  => ACCEPT release DO ii := 3; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 4 = 5  => ACCEPT release DO ii := 4; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 5 = 5  => ACCEPT release DO ii := 5; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 6 = 5  => ACCEPT release DO ii := 6; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 7 = 5  => ACCEPT release DO ii := 7; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 8 = 5  => ACCEPT release DO ii := 8; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   --     OR WHEN 9 = 5  => ACCEPT release DO ii := 9; END;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   --     END SELECT;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- END LOOP;   --   can be folded");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
		----------------------------------------------------
		-- +++ tcl 2-8-89 make ancillary information self-identifying
    zg_glob2.put_ancillary(" >>> tk_ls_task_29 time per rendezvous = ");
    zg_glob2.put_value( (zg_glob3.min_time * 1_000_000.0 / 20.0), 8, 1, 0);
    zg_glob2.put_new_line;
                ----------------------------------------------------
 
    ABORT resource;    -- stop execution
  END main;
 
BEGIN
  NULL;
END tk_ls_task_29;
