-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- tk_ls_task_33

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH system;
 
PACKAGE pkg01_tk_ls18 IS
 
  TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    ENTRY entry1;
    ENTRY initialization_complete;
  END resource;
 
END pkg01_tk_ls18;
 
PACKAGE BODY pkg01_tk_ls18 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK BODY resource IS
  BEGIN
 
 
    ACCEPT initialization_complete;
 
    --
    -- Test Name         :  tk_ls_task_33
    -- Prime Purpose     :  Language feature test of aspects of tasking.
    --                      Conditional wait in accepting task, will always
    --                      take the ELSE alternative.
    -- LRM Version       :  A
    -- Optimization      :
    -- Related tests     :  tk_ls_task_32
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
 
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_ls_task_33");

    PRAGMA include("startime");

    SELECT
      ACCEPT entry1;    -- never called
      RAISE program_error;
    ELSE
      NULL;
    END SELECT;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   measure time to check entry queue");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   SELECT");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("      ACCEPT entry1; -- entry is never linked to ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   ELSE ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      NULL;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END SELECT;");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
  
  EXCEPTION
    WHEN program_error =>
      zg_glob2.put_comment("ERROR ");
      zg_glob2.put_new_line;
      zg_glob2.put_error_code (zg_glob1.err_at_execution_time);
 
  END resource;
END pkg01_tk_ls18;
 
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
WITH pkg01_tk_ls18;
USE  pkg01_tk_ls18;
WITH system;
 
PROCEDURE tk_ls_task_33 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
  END main;
 
 
  TASK BODY main IS
  BEGIN
    resource.initialization_complete;    -- entry call to sync
    LOOP
      EXIT WHEN resource'terminated;
      IF zg_glob4.ll = zg_glob4.mm THEN  -- never true
					 --  resource.entry1; -- never linked
        EXIT;                            -- terminate task main if this is
                                         -- entered
      ELSE
        DELAY 1.0;
      END IF;
    END LOOP;
  END main;
 
BEGIN
  NULL;
END tk_ls_task_33;
