-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- tk_ls_task_35

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH system;
 
PACKAGE pkg01_tk_ls20 IS
 
  TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    ENTRY entry1;
    ENTRY initialization_complete;
  END resource;
 
END pkg01_tk_ls20;
 
PACKAGE BODY pkg01_tk_ls20 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK BODY resource IS
  BEGIN
 
 
    ACCEPT initialization_complete;
 
    --
    -- Test Name         :  tk_ls_task_35
    -- Prime Purpose     :  Language feature test of aspects of tasking. 
    --                      Selective wait in accepting task. Will always take 
    --                      the DELAY alternative, which will expire without 
    --                      an entry call being made.
    -- LRM Version       :  A
    -- Optimization      :  Nonpositive delay -
    --                      DELAY of 0.0 (or negative value) can be special-
    --                      cased at compile time for static expressions.
    -- Related tests     :  tk_ls_task_34
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Info        :
    --
 
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_ls_task_35");

    PRAGMA include("startime");

    SELECT
      ACCEPT entry1;    -- never called
    OR
      DELAY 0.000;
    END SELECT;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   measure time to check entry queue");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   SELECT");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      ACCEPT entry1; -- never called");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      DELAY 0.0;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END SELECT;");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
  END resource;
END pkg01_tk_ls20;
 
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob4;

WITH calendar;
USE  calendar;
WITH pkg01_tk_ls20;
USE  pkg01_tk_ls20;
WITH system;
PROCEDURE tk_ls_task_35 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
  END main;
 
 
  TASK BODY main IS
  BEGIN
    resource.initialization_complete;    -- sync with task resource
    LOOP
      EXIT WHEN resource'terminated;
      IF zg_glob4.ll = zg_glob4.mm THEN  -- never true
        resource.entry1;                 -- never taken
        EXIT;                            -- terminate loop if reach here
      ELSE
        DELAY 1.0;
      END IF;
    END LOOP;
  END main;
 
BEGIN
  NULL;
END tk_ls_task_35;
