-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- +++ tcl 2-8-89 change to make ancillary information self-identifying
-- tk_ls_task_36

WITH zg_glob1;
PACKAGE pkg01_tk_ls21 IS
 
  TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
    ENTRY request;
    ENTRY release;
  END resource;
END pkg01_tk_ls21;
 
PACKAGE BODY pkg01_tk_ls21 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK BODY resource IS
  BEGIN
    LOOP
      ACCEPT request;
      ACCEPT release;
    END LOOP;
  END resource;
END pkg01_tk_ls21;
 
 
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;

WITH calendar;
USE  calendar;
WITH pkg01_tk_ls21;
USE  pkg01_tk_ls21;
WITH system;
 
PROCEDURE tk_ls_task_36 IS
  
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END main;
 
 
  TASK BODY main IS
  BEGIN
 
    --
    -- Test Name         :  tk_ls_task_36
    -- Prime Purpose     :  Language feature test of aspects of tasking. 
    --                      Entering task makes a sequence of calls.  
    --                      Accepting task contains a conditional SELECT with 
    --                      ELSE alternatives which are never taken.  Entering 
    --                      task will arrive at rendezvous first.
    -- LRM Version       :  A
    -- Optimization      :
    -- Related tests     :
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
  
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_ls_task_36");

    PRAGMA include("startime");

    FOR i IN 1 .. 10 LOOP
      SELECT
        resource.request;    -- should always be taken
      ELSE
        zg_glob4.die;        -- never taken
      END SELECT;
      SELECT
        resource.release;
      ELSE
        zg_glob4.die;
      END SELECT;
    END LOOP;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   FOR i IN 1..10 ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      SELECT ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("        resource.request;  -- should always be taken");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      ELSE ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("        die;               -- never taken");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      END SELECT;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      SELECT");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("        resource.release;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      ELSE");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("        die;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      END SELECT;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END LOOP;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- priorities are such that task accepting entry call will");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- arrive at rendezvous first");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- primarily a test of conditional calls, which are taken");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
		----------------------------------------------------
		-- +++ tcl 2-8-89 make ancillary information self-identifying
    zg_glob2.put_ancillary(" >>> tk_ls_task_36 time per rendezvous = ");
    zg_glob2.put_value( (zg_glob3.min_time * 1_000_000.0 / 20.0), 8, 1, 0);
    zg_glob2.put_new_line;
                ------------------------------------------------------
 
    ABORT resource;          -- stop execution
  END main;
 
BEGIN
  NULL;
END tk_ls_task_36;
