-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
--+ TCL 12 DEC 90 modified to correct PCR #81, last line of program lost in
--+               in buffer without being output.

-- tk_ls_task_58 task with multiple open accepts

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH system;
 
PROCEDURE tk_ls_task_58 IS
 
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK requester1 IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END requester1;
 
  TASK requester2 IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END requester2;
 
  TASK requester3 IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END requester3;
 
  TASK requester4 IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END requester4;
 
  TASK requester5 IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END requester5;
 
  TASK requester6 IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END requester6;
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
    ENTRY request1;
    ENTRY request2;
    ENTRY request3;
    ENTRY request4;
    ENTRY request5;
    ENTRY request6;
  END main;
 
  guard1  : boolean := true;
  guard2  : boolean := true;
  guard3  : boolean := true;
  guard4  : boolean := true;
  guard5  : boolean := true;
  guard6  : boolean := true;
  lexical : boolean := true;
  dummy   : boolean;
 
  TASK BODY requester1 IS
  BEGIN
    LOOP
      main.request1;
    END LOOP;
  END requester1;
 
  TASK BODY requester2 IS
  BEGIN
    LOOP
      main.request2;
    END LOOP;
  END requester2;
 
  TASK BODY requester3 IS
  BEGIN
    LOOP
      main.request3;
    END LOOP;
  END requester3;
 
  TASK BODY requester4 IS
  BEGIN
    LOOP
      main.request4;
    END LOOP;
  END requester4;
 
  TASK BODY requester5 IS
  BEGIN
    LOOP
      main.request5;
    END LOOP;
  END requester5;
 
  TASK BODY requester6 IS
  BEGIN
    LOOP
      main.request6;
    END LOOP;
  END requester6;
 
  TASK BODY main IS
  BEGIN
 
    --
    -- Test Name         :  tk_ls_task_58
    -- Prime Purpose     :  To measure the time required when a task has
    --                      multiple open accepts. The accepts can 
    --                      theoretically be done in a nondeterministic order. 
    --                      Each open select will be accepted one time for each 
    --                      iteration of the timing loop. The test notes if
    --                      the accepts were done in lexical order.
    -- LRM Version       :  Revision A
    -- Optimization      :
    -- Related tests     :  tk_ls_task_60
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
    -----------------------------------------------------------------------
    -- Revisions       : For ACEC release 2.1 changed PUT statement just
    --                   prior to terminating program to PUT_LINE statements.
    --                   This should not invalidate comparisons with version 
    --                   2.0 of this program.
    -- Author          : T. Leavitt
    -- Reviewer        : B. Decker-Lindsey
    -- Date            : 12 DEC 1990

    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_ls_task_58");

    PRAGMA include("startime");

    FOR i IN 1 .. 6 LOOP
      SELECT
        WHEN guard1 =>
          ACCEPT request1 DO
            guard1 := false;       -- don't accept until next timing loop
            IF i /= 1 THEN         -- Accepted out of lexical order?
              lexical := false;    -- Yes, save the fact
            ELSE
              dummy := false;      -- gives the same timing as lexical := false;
            END IF;
          END request1;
      OR
        WHEN guard2 =>
          ACCEPT request2 DO
            guard2 := false;
            IF i /= 2 THEN
              lexical := false;
            ELSE
              dummy := false;
            END IF;
          END request2;
      OR
        WHEN guard3 =>
          ACCEPT request3 DO
            guard3 := false;
            IF i /= 3 THEN
              lexical := false;
            ELSE
              dummy := false;
            END IF;
          END request3;
      OR
        WHEN guard4 =>
          ACCEPT request4 DO
            guard4 := false;
            IF i /= 4 THEN
              lexical := false;
            ELSE
              dummy := false;
            END IF;
          END request4;
      OR
        WHEN guard5 =>
          ACCEPT request5 DO
            guard5 := false;
            IF i /= 5 THEN
              lexical := false;
            ELSE
              dummy := false;
            END IF;
          END request5;
      OR
        WHEN guard6 =>
          ACCEPT request6 DO
            guard6 := false;
            IF i /= 6 THEN
              lexical := false;
            ELSE
              dummy := false;
            END IF;
          END request6;
      END SELECT;
    END LOOP;
    guard1 := true;
    guard2 := true;
    guard3 := true;
    guard4 := true;
    guard5 := true;
    guard6 := true;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   Task with multiple open accepts");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   The open accepts in this test can be accepted in a");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   nondeterministic order. The test will note whether or");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   not the accepts where processed in lexical order.");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   FOR i IN 1..6");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("    SELECT");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      WHEN guard1 =>  ACCEPT request1 DO");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("        guard1 := false;  -- don't accept until next timing loop");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("        IF i /= 1 THEN       -- Accepted out of lexical order?");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("          lexical := false;  -- Yes, save the fact");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("        ELSE");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("          dummy := false; -- same timing as lexical := false;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("        END IF;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      END request1;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("            :");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("            :");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      WHEN guard6 =>  ACCEPT request6 DO");
    zg_glob2.put_new_line_optional;                                      
    zg_glob2.put_comment_optional("        guard6 := false;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("        IF i /= 6 THEN");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("          lexical := false;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("        ELSE");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("          dummy := false;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("        END IF;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      END request6;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END LOOP;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   guard1 := true;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("     :");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   guard6 := true;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- priorities are such that task making entry call will");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- arrive at rendezvous first");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- compare with tk_ls_task_60");

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
--+ TCL 12 DEC 90 modified to correct PCR #81, last line of program lost in
--+               in buffer without being output.
--+               "put" statements changes to "put_line"

    IF lexical THEN
      zg_glob2.put_ancillary
(" >>> tk_ls_task_58 This system selects open accepts in lexical order");
      zg_glob2.put_new_line;
    ELSE
      zg_glob2.put_ancillary
(" >>> tk_ls_task_58 This system doesn't select open accepts in lexical order");
      zg_glob2.put_new_line;
    END IF;
 
    ABORT requester1;              -- clean up spare tasks
    ABORT requester2;
    ABORT requester3;
    ABORT requester4;
    ABORT requester5;
    ABORT requester6;
  END main;
 
BEGIN
  NULL;
END tk_ls_task_58;
