--+ KET 9/14/89 modified to correct Eilers #7
 
-- tk_ls_task_59 task with multiple delay alternatives

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;

WITH calendar;
USE  calendar;
 
PROCEDURE tk_ls_task_59 IS
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK main IS
    ENTRY dummy;
  END main;
 
  --+ KET 9/14/89 modified to correct Eilers #7
  d1  : CONSTANT duration := duration(-zg_glob4.e1(1));
  d2  : CONSTANT duration := duration(-zg_glob4.e1(2));
  d3  : CONSTANT duration := duration(-zg_glob4.e1(3));
  d4  : CONSTANT duration := duration(-zg_glob4.e1(4));
  d5  : CONSTANT duration := duration(-zg_glob4.e1(5));
  d6  : CONSTANT duration := duration(-zg_glob4.e1(6));
  d7  : CONSTANT duration := duration(-zg_glob4.e1(7));
  d8  : CONSTANT duration := duration(-zg_glob4.e1(8));
  d9  : CONSTANT duration := duration(-zg_glob4.e1(9));
  d10 : CONSTANT duration := duration(-zg_glob4.e1(10));
  d11 : CONSTANT duration := duration(-2.0 * zg_glob4.e1(1) + zg_glob4.e1(2));
  d12 : CONSTANT duration := duration(-2.0 * zg_glob4.e1(1) + zg_glob4.e1(3));
 
  --+ KET 9/14/89 modified to correct Eilers #7
  --+ always_false: boolean := false;
 
  TASK BODY main IS
  BEGIN
 
    --
    -- Test Name         :  tk_ls_task_59
    -- Prime Purpose     :  To evaluate the performance of a task with multiple
    --                      delay alternatives. The LRM permits a select to have
    --                      multiple delay alternatives.
    -- LRM Version       :  Revision A
    -- Optimization      :
    -- Related tests     :
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
 
    --+ KET 9/14/89 modified to correct Eilers #7
    zg_glob1.bool := false;
 
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_ls_task_59");

    PRAGMA include("startime");

    SELECT
      --+ KET 9/14/89 modified to correct Eilers #7
      --+    when always_false =>
      WHEN zg_glob1.bool =>    -- always false
        ACCEPT dummy;
    OR
      DELAY d1;
    OR
      DELAY d2;
    OR
      DELAY d3;
    OR
      DELAY d4;
    OR
      DELAY d5;
    OR
      DELAY d6;
    OR
      DELAY d7;
    OR
      DELAY d8;
    OR
      DELAY d9;
    OR
      DELAY d10;
    OR
      DELAY d11;
    OR
      DELAY d12;
    END SELECT;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   task with multiple delay alternatives");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   SELECT");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      WHEN bool =>  -- always false ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("         ACCEPT dummy;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      DELAY d1;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      DELAY d2;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      DELAY d3;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("       :");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("       :");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      DELAY d12;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END SELECT;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- the condition on the accept statement will never be true");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- and d1 ... d12 are all negative");

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
  END main;
 
BEGIN
  NULL;
END tk_ls_task_59;
