-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
-- tk_ls_task_60 task with multiple accepts done in lexical order

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH system;
 
PROCEDURE tk_ls_task_60 IS
 
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
 
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
  TASK requester1 IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END requester1;
 
  TASK requester2 IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END requester2;
 
  TASK requester3 IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END requester3;
 
  TASK requester4 IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END requester4;
 
  TASK requester5 IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END requester5;
 
  TASK requester6 IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
  END requester6;
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
    ENTRY request1;
    ENTRY request2;
    ENTRY request3;
    ENTRY request4;
    ENTRY request5;
    ENTRY request6;
  END main;
 
  guard1 : boolean := true;
  guard2 : boolean := false;
  guard3 : boolean := false;
  guard4 : boolean := false;
  guard5 : boolean := false;
  guard6 : boolean := false;
 
  TASK BODY requester1 IS
  BEGIN
    LOOP
      main.request1;
    END LOOP;
  END requester1;
 
  TASK BODY requester2 IS
  BEGIN
    LOOP
      main.request2;
    END LOOP;
  END requester2;
 
  TASK BODY requester3 IS
  BEGIN
    LOOP
      main.request3;
    END LOOP;
  END requester3;
 
  TASK BODY requester4 IS
  BEGIN
    LOOP
      main.request4;
    END LOOP;
  END requester4;
 
  TASK BODY requester5 IS
  BEGIN
    LOOP
      main.request5;
    END LOOP;
  END requester5;
 
  TASK BODY requester6 IS
  BEGIN
    LOOP
      main.request6;
    END LOOP;
  END requester6;
 
  TASK BODY main IS
  BEGIN
 
 
    --
    -- Test Name         :  tk_ls_task_60
    -- Prime Purpose     :  To measure the time required when a task has
    --                      multiple accepts and is forced to process them 
    --                      in lexical order by opening
    --                      them one at a time in lexical order. This
    --                      is done in order to compare with the
    --                      nondeterministic case. Each select will be opened
    --                      and accepted one time (in lexical order) for each
    --                      iteration of the timing loop.
    -- LRM Version       :  Revision A
    -- Optimization      :
    -- Related tests     :  tk_ls_task_58
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
 
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_ls_task_60");

    PRAGMA include("startime");

    FOR i IN 1 .. 6 LOOP
      SELECT
        WHEN guard1 =>
          ACCEPT request1 DO
            guard1 := false;    -- don't accept until next timing loop
            guard2 := true;     -- open the next accept statement
          END request1;
      OR
        WHEN guard2 =>
          ACCEPT request2 DO
            guard2 := false;
            guard3 := true;
          END request2;
      OR
        WHEN guard3 =>
          ACCEPT request3 DO
            guard3 := false;
            guard4 := true;
          END request3;
      OR
        WHEN guard4 =>
          ACCEPT request4 DO
            guard4 := false;
            guard5 := true;
          END request4;
      OR
        WHEN guard5 =>
          ACCEPT request5 DO
            guard5 := false;
            guard6 := true;
          END request5;
      OR
        WHEN guard6 =>
          ACCEPT request6 DO
            guard6 := false;
            guard1 := true;
          END request6;
      END SELECT;
    END LOOP;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   Task with multiple accepts done in lexical order- ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   Measures the time required when a task has multiple ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   accepts and is forced process them in lexical order by ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   opening them one at a time in lexical order. This is ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   done in order to compare with the nondeterministic   ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   case. Each select will be opened and accepted one time ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   (in lexical order) for each iteration of the timing loop.");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   FOR i IN 1..6");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   LOOP");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      SELECT");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("         WHEN guard1 =>  ACCEPT request1 DO");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("            guard1 := false; -- don't accept until next timing loop");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("            guard2 := true;  -- open the next accept statement");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("         END request1;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("             :");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("             :");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      OR");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("         WHEN guard6 =>  ACCEPT request6 DO");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("            guard6 := false;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("            guard1 := true; ");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("         END request6;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("      END SELECT;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   END LOOP;");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional
	("   -- priorities are such that task making entry call will");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- arrive at rendezvous first");
    zg_glob2.put_new_line_optional;
    zg_glob2.put_comment_optional("   -- compare with tk_ls_task_58");

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
    ABORT requester1;           -- clean up spare tasks
    ABORT requester2;
    ABORT requester3;
    ABORT requester4;
    ABORT requester5;
    ABORT requester6;
  END main;
 
BEGIN
  NULL;
END tk_ls_task_60;
