with zg_glob1;
use  zg_glob1;
with zg_glob2;
with zg_glob3;
with zg_glob4;
with calendar;
use  calendar;

procedure tk_ls_task_75 is

pragma suppress(access_check);
pragma suppress(discriminant_check);
pragma suppress(index_check);
pragma suppress(length_check);
pragma suppress(range_check);
pragma suppress(division_check);
pragma suppress(overflow_check);
pragma suppress(elaboration_check);
pragma suppress(storage_check);

pragma OPTIMIZE (TIME);

   old_calling_task : zg_glob1.integer16 := 0;
   pragma shared (old_calling_task);

   number_of_task_switches : zg_glob1.integer16 := 0;
   pragma shared (number_of_task_switches);

   number_of_calls_on_check_in : zg_glob1.integer16 := 0;
   pragma shared (number_of_calls_on_check_in);

             -- number_of_loops_of_select_statement is selected to be large 
             -- enough that the selecting tasks will execute for a significant
             -- amount of time (enough to detect a system that does switch 
             -- tasks after a number of attempts to rendezvous).  It should 
             -- also be small enough so that when multiplied by 5 it is still 
             -- less than ZG_GLOB1.INTEGER16'LAST (32767) to avoid overflowing
             -- the variable NUMBER_OF_TASK_SWITCHES for a system which 
             -- switches tasks after every failure to rendezvous. 
   number_of_loops_of_select_statement : constant := 6_000 ;

   minimum_number_of_calls_on_check_in : zg_glob1.integer16 := 
         5 * number_of_loops_of_select_statement ;

   procedure check_in ( calling_task : zg_glob1.integer16 ) ;
   pragma inline (check_in);

   procedure check_in ( calling_task : zg_glob1.integer16 ) is
   begin
     if calling_task /= old_calling_task then 
       old_calling_task := calling_task ;
       number_of_task_switches := number_of_task_switches + 1 ;
     end if;
     number_of_calls_on_check_in := number_of_calls_on_check_in + 1;
     if zg_glob3.boolean_false then                                        
        zg_glob4.proci1( old_calling_task );                               
        zg_glob4.proci1( number_of_task_switches );                        
        zg_glob4.proc1( zg_glob1.float6( number_of_calls_on_check_in ));   
     end if;                                                               
   end check_in ;

   task type T1 is
      pragma PRIORITY (zg_glob1.priority_1) ;
      entry e ;
   end T1;

   task type T2 is
      pragma PRIORITY (zg_glob1.priority_1) ;
      entry e ;
   end T2;

   task type T3 is
      pragma PRIORITY (zg_glob1.priority_1) ;
      entry e ;
   end T3;

   task type T4 is
      pragma PRIORITY (zg_glob1.priority_1) ;
      entry e ;
   end T4;

   task type T5 is
      pragma PRIORITY (zg_glob1.priority_1) ;
      entry e ;
   end T5;

   task body T1 is
   begin
      for I in 1 .. number_of_loops_of_select_statement 
      loop
         select
            accept E do
               zg_glob4.die; 
            end;
         else
            check_in(1); 
            if zg_glob3.boolean_false then
              zg_glob4.die; 
              zg_glob4.ii := zg_glob1.integer16(i);
              zg_glob4.proci1( zg_glob4.ii );
            end if;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
         end select;
      end loop;
   exception when others =>
     zg_glob2.put_comment(" exception raised in T1");
     zg_glob2.put_new_line; 
     zg_glob4.die;
   end T1;

   task body T2 is
   begin
      for I in 1 .. number_of_loops_of_select_statement 
      loop
         select
            accept E do
               zg_glob4.die; 
            end;
         else
            check_in(2); 
            if zg_glob3.boolean_false then
              zg_glob4.proc0;
              zg_glob4.ii := zg_glob1.integer16(i);
              zg_glob4.proci1( zg_glob4.ii );
            end if;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
         end select;
      end loop;
   exception when others =>
     zg_glob2.put_comment(" exception raised in T2");
     zg_glob2.put_new_line; 
     zg_glob4.die;
   end T2;

   task body T3 is
   begin
      for I in 1 .. number_of_loops_of_select_statement 
      loop
         select
            accept E do
               zg_glob4.die; 
            end;
         else
            check_in(3); 
            if zg_glob3.boolean_false then
              zg_glob4.proc0;
              zg_glob4.ii := zg_glob1.integer16(i);
              zg_glob4.proci1( zg_glob4.ii );
            end if;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
         end select;
      end loop;
   exception when others =>
     zg_glob2.put_comment(" exception raised in T3");
     zg_glob2.put_new_line; 
     zg_glob4.die;
   end T3;

   task body T4 is
   begin
      for I in 1 .. number_of_loops_of_select_statement 
      loop
         select
            accept E do
               zg_glob4.die; 
            end;
         else
            check_in(4); 
            if zg_glob3.boolean_false then
              zg_glob4.proc0;
              zg_glob4.ii := zg_glob1.integer16(i);
              zg_glob4.proci1( zg_glob4.ii );
            end if;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
         end select;
      end loop;
   exception when others =>
     zg_glob2.put_comment(" exception raised in T4");
     zg_glob2.put_new_line; 
     zg_glob4.die;
   end T4;

   task body T5 is
   begin
      for I in 1 .. number_of_loops_of_select_statement 
      loop
         select
            accept E do
               zg_glob4.die; 
            end;
         else
            check_in(5); 
            if zg_glob3.boolean_false then
              zg_glob4.proc0;
              zg_glob4.ii := zg_glob1.integer16(i);
              zg_glob4.proci1( zg_glob4.ii );
            end if;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
            zg_glob4.proc0;
         end select;
      end loop;
   exception when others =>
     zg_glob2.put_comment(" exception raised in T5");
     zg_glob2.put_new_line; 
     zg_glob4.die;
   end T5;


task main is 
   pragma PRIORITY (zg_glob1.priority_2) ;
   entry start;
   entry finish;
end main;

task body main is
begin
  -- Test Name         :  tk_ls_task_75
  -- Prime Purpose     :  This test determines whether the system is "fair"
  --                      in the sense that it will not execute the ELSE 
  --                      alternative of a selective wait statement more 
  --                      than a small number of times before a reschedule
  --                      is forced. Tasks of equal priority are used. 
  --                      A system which switches between equal priority tasks
  --                      in such cases will have a higher overhead than
  --                      one which does not, and programs written to 
  --                      exploit the "fairness" of the scheduler will 
  --                      have restricted portability. It may be better 
  --                      practice to avoid coding a "busy loop" with a 
  --                      SELECT and an ELSE alternative for equal priority
  --                      tasks. 
  -- Optimization      :
  -- Related tests     :  
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  B. Decker-Lindsey  -  1 April 1992
  -- Date              :  11 March 1992
  -- Source            :  AES Test TL08
  -- Dependencies      :  The logic behind the problem requires that the 
  --                      system NOT use time-slicing because task switches
  --                      forced by quantum expiration could be confused with
  --                      task switches caused by rescheduling due to ELSE
  --                      statements being repetitively selected. 
  -- Other Information :  

   accept start ;

   zg_glob2.put_test_name("tk_ls_task_75");
 
   pragma include("startime");
     old_calling_task := 0;
     number_of_task_switches := 0;
     number_of_calls_on_check_in := 0;
     declare 
       task1 : t1;
       task2 : t2;
       task3 : t3;
       task4 : t4;
       task5 : t5;
     begin
       while zg_glob3.boolean_false 
       loop
         task1.e;
         task2.e;
         task3.e;
         task4.e;
         task5.e;
         zg_glob3.boolean_false := not zg_glob3.boolean_false or 
                                   zg_glob4.ll = zg_glob4.mm;
         zg_glob4.die;
       end loop;
     end;                        -- will not exit block until tasks complete

     minimum_number_of_calls_on_check_in := 
         zg_glob1.min( minimum_number_of_calls_on_check_in, 
                       number_of_calls_on_check_in );

   pragma include ("stoptime0");
   zg_glob2.put_comment_optional(
   "   This test determines whether the system is ""fair"" in the sense ");
   zg_glob2.put_new_line_optional;
   zg_glob2.put_comment_optional(
   "   that it will not execute the ELSE alternative of a selective wait");
   zg_glob2.put_new_line_optional;
   zg_glob2.put_comment_optional(
   "   statement more than a small number of times before a reschedule");
   zg_glob2.put_new_line_optional;
   zg_glob2.put_comment_optional(
   "   is forced.  Tasks of equal priority are used.  A system which ");
   zg_glob2.put_new_line_optional;
   zg_glob2.put_comment_optional(
   "   switches between equal priority tasks in such cases will have a ");
   zg_glob2.put_new_line_optional;
   zg_glob2.put_comment_optional(
   "   higher overhead than one which does not, and programs written to ");
   zg_glob2.put_new_line_optional;
   zg_glob2.put_comment_optional(
   "   exploit the ""fairness"" of the scheduler will have restricted ");
   zg_glob2.put_new_line_optional;
   zg_glob2.put_comment_optional(
   "   portability.  It may be better general practice to avoid coding a ");
   zg_glob2.put_new_line_optional;
   zg_glob2.put_comment_optional(
   "   ""busy-loop"" with a SELECT and an ELSE alternative. ");
   pragma include ("stoptime2");
  
 
   zg_glob2.put_ancillary(" >>> tk_ls_task_75 ");
   if    minimum_number_of_calls_on_check_in < 
         5 * number_of_loops_of_select_statement then 
                -- If numbers are not equal, this implies that updates to 
                -- NUMBER_OF_CALLS_ON_CHECK_IN were not atomic and the system 
                -- switches tasks "in the middle" of incrementing the 
                -- counter. This would NOT happen if the task scheduler
                -- were executing in a run-till-blocked mode, so we conclude 
                -- that some form of time-slicing has been enabled.  When 
                -- this is so, the logic of determining whether task 
                -- switches occurred due to SELECT statement ELSE 
                -- alternative being chosen failed because we cannot 
                -- distinguish between rescheduling due to time-slicing 
                -- or due to ELSE alternative selection.
     zg_glob2.put_comment(
       "Discrepancy in number of calls on CHECK_IN. System appears to be");
     zg_glob2.put_new_line;
     zg_glob2.put_ancillary(" >>> tk_ls_task_75 " &
       "performing time-slicing. This test will not operate as intended");
     zg_glob2.put_new_line;
     zg_glob2.put_ancillary(" >>> tk_ls_task_75 " &
       "in that mode.  MINIMUM_NUMBER_OF_CALLS_ON_CHECK_IN is "); 
     zg_glob2.put_value( minimum_number_of_calls_on_check_in, 4 ); 
     zg_glob2.put_new_line;
     zg_glob2.put_ancillary(" >>> tk_ls_task_75 " &
       "but should be ");
     zg_glob2.put_value( number_of_loops_of_select_statement*5, 4 ); 
     zg_glob2.put_comment(". Increments are not atomic operations.");
     zg_glob2.put_new_line;
     zg_glob2.put_ancillary(" >>> tk_ls_task_75 " &
       "Was not able to reliably determine whether system reschedules ");
     zg_glob2.put_new_line;
     zg_glob2.put_ancillary(" >>> tk_ls_task_75 " &
       "equal priority tasks which take the ELSE alternative. ");
   elsif number_of_task_switches = 5 then
     zg_glob2.put_comment(
       "There was NO task switching detected when SELECT statements took");
     zg_glob2.put_new_line;
     zg_glob2.put_ancillary(" >>> tk_ls_task_75 " &
       "the ELSE alternative repetitively. It is possible that a larger value");
     zg_glob2.put_new_line;
     zg_glob2.put_ancillary(" >>> tk_ls_task_75 " &
       "of NUMBER_OF_LOOPS_OF_SELECT_STATEMENT might detect such switching.");
   elsif number_of_task_switches = number_of_loops_of_select_statement * 5 then
     zg_glob2.put_comment(
       "Every selection of an ELSE alternative forced a task switch. ");
   else
     zg_glob2.put_comment(
       "The average number of times the ELSE alternative in a SELECT ");
     zg_glob2.put_new_line;
     zg_glob2.put_ancillary(" >>> tk_ls_task_75 " &
       "statement is executed before the task is rescheduled was ");
     zg_glob2.put_value( 
          zg_glob1.float6(number_of_loops_of_select_statement) * 5.0 / 
          zg_glob1.float6(number_of_task_switches - 5)  , 
          4, 1, 0);
     zg_glob2.put_comment(".");
   end if;
   zg_glob2.put_new_line;

   accept finish; 
end main ;

begin
  main.start ;
  main.finish;   
end tk_ls_task_75 ;
