-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH system;

PROCEDURE tk_rz_task_01_num_05 IS
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
  END main;
   
  TASK TYPE resource IS 
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    ENTRY request;
    ENTRY release;
  END resource;
   
  t1, t2, t3, t4, t5 : resource;
   
  TASK BODY resource IS
  BEGIN
    LOOP
      ACCEPT request;
      ACCEPT release;
    END LOOP;
  END resource;
   
  TASK BODY main IS
  BEGIN
   
     
    --
    -- Test Name         :  tk_rz_task_01_num_05
    -- Prime Purpose     :  Test the performance of rendezvous when you vary
    --                      the number of tasks.  This test has 5.
    -- LRM Version       :  Revision A
    -- Optimization      :
    -- Related tests     :  tk_rz_task_01_num_30, tk_rz_task_01_num_25, 
    -- Related tests     :  tk_rz_task_01_num_20, tk_rz_task_01_num_15,
    -- Related tests     :  tk_rz_task_01_num_10, tk_rz_task_01_num_01
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --
     
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_rz_task_01_num_05");

    PRAGMA include("startime");

    t1.request;
    t1.release;
    t2.request;
    t2.release;
    t3.request;
    t3.release;
    t4.request;
    t4.release;
    t5.request;
    t5.release;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   10 entry calls, 5 different tasks");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
     
    --+ TJT 09-15-89 Modified to correct Eilers #6
    --+ time_num_10 := ( min_time * 1_000_000.0 / 20.0 );
     
		----------------------------------------------------
		-- +++ tcl 2-8-89 make ancillary information self-identifying
    zg_glob2.put_ancillary(" >>> tk_rz_task_01_num_05 time per rendezvous = ");
    zg_glob2.put_value( (zg_glob3.min_time * 1_000_000.0 / 20.0), 8, 1, 0);
    zg_glob2.put_new_line;
		----------------------------------------------------
     
    ABORT t1, t2, t3, t4, t5 ;
     
  END main;
 
BEGIN
  NULL;
  --+ KET modified during review 19 Oct 1989
  --+ exception
  --+ when others =>
  --+ TJT 09-15-89 Modified to correct Eilers #6
  --+  time_num_10 := -1.0; -- failed, probably due to storage error
  --+  null;    --+ TJT 09-15-89 Modified to correct Eilers #6
END tk_rz_task_01_num_05;
