-- +++ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;

WITH calendar;
USE  calendar;
WITH system;
 
PROCEDURE tk_rz_task_02_num_01 IS
 
  TASK main IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_2 );
  END main;
 
  TASK TYPE requestor IS 
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_3 );
    ENTRY doit;
  END requestor;
 
  TASK resource IS
         --+ tcl 6 Aug 91 modified to correct PCR #90, literal priorities
      PRAGMA priority( zg_glob1.priority_1 );
    ENTRY request;
    ENTRY release;
  END resource;
 
  t1 : requestor;
 
  TASK BODY resource IS
  BEGIN
    LOOP
      ACCEPT request;
      ACCEPT release;
    END LOOP;
  END resource;
 
  TASK BODY requestor IS
  BEGIN
    LOOP
      ACCEPT doit;
      resource.request;
      resource.release;
    END LOOP;
  END requestor;
 
 
  TASK BODY main IS
  BEGIN
 
  
    --
    -- Test Name         :  tk_rz_task_02_num_01
    -- Prime Purpose     :  Test the performance of rendezvous when you vary
    --                      the number of tasks.  This test has 01.
    -- LRM Version       :  Revision A
    -- Optimization      :
    -- Related tests     :  tk_rz_task_02_num_30, tk_rz_task_02_num_25, 
    -- Related tests     :  tk_rz_task_02_num_20, tk_rz_task_02_num_15, 
    -- Related tests     :  tk_rz_task_02_num_10, tk_rz_task_02_num_05
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Kermit E. Terrell
    -- Date              :
    -- Source            :
    -- Dependencies      :
    -- Other Information :  This test may fail with a STORAGE_ERROR.
    --
 
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("tk_rz_task_02_num_01");

    PRAGMA include("startime");

    resource.request;
    t1.doit;
    resource.release;

    PRAGMA include("stoptime0");

    zg_glob2.put_comment_optional("   5 entry calls, 1 requestors ");
    zg_glob2.put_new_line_optional;

    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
 
		----------------------------------------------------
		-- +++ tcl 2-8-89 make ancillary information self-identifying
    zg_glob2.put_ancillary(" >>> tk_rz_task_02_num_01 time per rendezvous = ");
    zg_glob2.put_value( (zg_glob3.min_time * 1_000_000.0 / 92.0), 8, 1, 0);
    zg_glob2.put_new_line;
		----------------------------------------------------
 
    --+ KET 10-19-89 modified during review
    --+ time_num_01 := ( min_time * 1_000_000.0 / 92.0 );
  
    ABORT t1 ;
    ABORT resource;
 
  END main;
 
BEGIN
  NULL;
 
  --+ KET 10-19-89 modified during review
  --+ exception
  --+  when others =>
  --+     Put ("tk_rz_task_02_num_01   ERROR:  Failed at execution time");
  --+     zg_glob2.put_error_code(err_at_execution_time);
END tk_rz_task_02_num_01;
