with zg_glob1;
use  zg_glob1;
with zg_glob2;
with zg_glob3;    
with zg_glob4;
with calendar;
use  calendar;
--with system;                    --+ tcl 7 April 1992, PCR #100 part 3
                                  --+    A "WITH SYSTEM;" may be necessary on
                                  --+    some compilers to use PRAGMA PRIORITY
                                  --+    even though Ada Interpretation
                                  --+    AI-00197 clearly states that it should
                                  --+    NOT be required.
 
package tk_rzpkg_31 IS
 
  shared_variable : zg_glob1.integer16 ; 
  pragma shared (shared_variable);

  TASK driver IS
    pragma priority( zg_glob1.priority_2 );
    entry start_program; 
    entry stop_program;
--    entry start_problem ;           --+ tcl, PCR #100, part 2, not needed
--    entry stop_problem ;            --+ tcl, PCR #100, part 2, not needed
  END driver ; 

  TASK task_1 IS
    pragma priority( zg_glob1.priority_1 );
    entry start_problem ; 
    entry stop_problem ;
    entry stop_program;
  END task_1 ;

  TASK task_2 IS
    pragma priority( zg_glob1.priority_1 );
    entry start_problem ;
    entry stop_problem ;
    entry stop_program;
  END task_2 ;
 
end tk_rzpkg_31; 

-------------------------------------------------------------------------

package body tk_rzpkg_31 is


  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

  TASK body task_1 IS
    exit_loop : boolean := false ;
  begin
   loop
     select 
       accept start_problem do 
         shared_variable := shared_variable + 1 ;
              -- Add one to SHARED_VARIABLE 500 times, subtract one 500 times.
              -- Want to reference it multiple times within rendezvous so that
              -- if the overheads of referencing a shared variable are large,
              -- they will not be swamped by the time to perform the initial
              -- rendezvous.
         zg_glob4.ii := zg_glob4.ei;
         for i in zg_glob1.integer16'(1) .. zg_glob1.integer16'(1000) 
         loop
           if zg_glob3.boolean_false then  -- never taken
             delay 1.0 ;
             shared_variable := shared_variable - zg_glob4.ii ;
             zg_glob3.boolean_false := not zg_glob3.boolean_false;
             zg_glob4.proc0;
           else
             zg_glob4.ii := - zg_glob4.ii;
           end if;
           shared_variable := shared_variable + zg_glob4.ii; 
         end loop;
       end start_problem; 

       for i in zg_glob4.e1'first .. zg_glob4.e1'last - 1 
       loop
         zg_glob4.e1(i) := zg_glob4.e1(i+1); 
       end loop;

       if zg_glob3.boolean_false then
         zg_glob3.boolean_false := not zg_glob3.boolean_false;
         zg_glob4.xx := 0.0; 
         for i in zg_glob4.e1'range
         loop
           zg_glob4.xx := zg_glob4.xx + zg_glob4.e1(i);
         end loop;
       end if;
      
       accept stop_problem ;
     or
       accept stop_program 
         do
           exit_loop := true; 
         end;
     end select;
     exit when exit_loop;
  end loop;
  
  END task_1 ;

  TASK body task_2 IS
    exit_loop : boolean := false ;
  begin
   loop
     select 
       accept start_problem do 
         shared_variable := shared_variable + 1 ;
              -- Add one to SHARED_VARIABLE 500 times, subtract one 500 times.
              -- Want to reference it multiple times within rendezvous so that
              -- if the overheads of referencing a shared variable are large,
              -- they will not be swamped by the time to perform the initial
              -- rendezvous.
         zg_glob4.ii := zg_glob4.ei;
         for i in zg_glob1.integer16'(1) .. zg_glob1.integer16'(1000) 
         loop
           if zg_glob3.boolean_false then  -- never taken
             delay 1.0 ;
             shared_variable := shared_variable - zg_glob4.ii ;
             zg_glob3.boolean_false := not zg_glob3.boolean_false;
             zg_glob4.proc0;
           else
             zg_glob4.ii := - zg_glob4.ii;
           end if;
           shared_variable := shared_variable + zg_glob4.ii ; 
         end loop;
       end start_problem; 

       for i in zg_glob4.e1'first .. zg_glob4.e1'last - 1 
       loop
         zg_glob4.e1(i) := zg_glob4.e1(i+1); 
       end loop;

       if zg_glob3.boolean_false then
         zg_glob3.boolean_false := not zg_glob3.boolean_false;
         zg_glob4.xx := 0.0; 
         for i in zg_glob4.e1'range
         loop
           zg_glob4.xx := zg_glob4.xx + zg_glob4.e1(i);
         end loop;
       end if;
      
       accept stop_problem ;
     or
       accept stop_program 
         do
           exit_loop := true; 
         end;
     end select;
     exit when exit_loop;
  end loop;
  
  END task_2 ;

  TASK BODY driver IS
  BEGIN
  
    accept start_program;
 
----------------------------------------------------------------------------
    -- Test Name         :  TK_RZ_TASK_02_NUM_31
    -- Prime Purpose     :  Test the overhead of updating a shared variable
    --                      within a rendezvous. 
    -- Optimization      :
    -- Related Tests     :  TK_RZ_TASK_02_NUM_32
    -- Author            :  T. Leavitt, 
    -- Reviewer          :  B. Decker-Lindsey  -  3 March 1992
    -- Date              :  December 1991
    -- Source            :  Test for this feature was recommended in CECOM 
    --                      report "Evaluation of the ACEC Benchmark Suite 
    --                      for Real-Time Applications." CIN:C02 092LY 0003 00, 
    --                      23 July 1990
    -- Dependencies      :  Support for PRAGMA SHARED
    -- Other Information :  
    -- Revisions         :  PCR #100
    -- Date              :  7 April 1992
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Julie Leastman - 15 April 1992
    -- Changes           :  Removed unused entry definitions in task DRIVER,
    --                      commented out WITH SYSTEM used to enable PRAGMA
    --                      PRIORITY of systems not complying with AI-00197,
    --                      and removed unneeded WITH clauses from procedure 
    --                      TK_RZ_TASK_02_NUM_31.
  
----------------------------------------------------------------------------

    zg_glob2.put_test_name("tk_rz_task_02_num_31 ");
    PRAGMA include("startime");
      shared_variable := 0;
      task_1.start_problem; 
      task_2.start_problem; 
      task_2.stop_problem; 
      task_1.stop_problem; 
      task_2.start_problem; 
      task_1.start_problem; 
      task_1.stop_problem; 
      task_2.stop_problem; 
      if shared_variable /= 4 then 
        zg_glob4.die; 
      end if;
    PRAGMA include("stoptime0");
      zg_glob2.put_comment_optional(
        "   Updates a shared variable within a  ");
      zg_glob2.put_new_line_optional;
      zg_glob2.put_comment_optional(
        "   rendezvous. Makes 8008 references to shared variable");
      zg_glob2.put_new_line_optional;
      zg_glob2.put_comment_optional(
        "   so that the rendezvous will not dominate time. All  ");
      zg_glob2.put_new_line_optional;
      zg_glob2.put_comment_optional(
        "   the references have the form ");
      zg_glob2.put_new_line_optional;
      zg_glob2.put_comment_optional(
        "         ""shared_variable := shared_variable + ..""  ");
      zg_glob2.put_new_line_optional;
      zg_glob2.put_comment_optional(
        "   so some optimization may be possible. ");
      zg_glob2.put_new_line_optional;
    PRAGMA include("stoptime2");

    task_1.stop_program; 
    task_2.stop_program; 

  accept stop_program; 

  end driver ;

end tk_rzpkg_31;

--------------------------------------------------------------------------------

--with zg_glob1;                  --+ tcl 7 April 1992, PCR #100 part 3
--use  zg_glob1;                  --+ tcl 7 April 1992, PCR #100 part 3
--with zg_glob2;                  --+ tcl 7 April 1992, PCR #100 part 3
--with zg_glob3;                  --+ tcl 7 April 1992, PCR #100 part 3
--with zg_glob4;                  --+ tcl 7 April 1992, PCR #100 part 3
--with calendar;                  --+ tcl 7 April 1992, PCR #100 part 3
--use  calendar;                  --+ tcl 7 April 1992, PCR #100 part 3
--with system;                    --+ tcl 7 April 1992, PCR #100 part 3
                                  --+    A "WITH SYSTEM;" may be necessary on
                                  --+    some compilers to use PRAGMA PRIORITY
                                  --+    even though Ada Interpretation
                                  --+    AI-00197 clearly states that it should
                                  --+    NOT be required.
with tk_rzpkg_31; 

procedure tk_rz_task_02_num_31 is

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

BEGIN
  tk_rzpkg_31.driver.start_program;
  tk_rzpkg_31.driver.stop_program;
END tk_rz_task_02_num_31 ; 
