with zg_glob1;
use  zg_glob1;
with zg_glob2;
with zg_glob3;
with zg_glob4;
with calendar;
use  calendar;
--with system;                    --+ tcl 7 April 1992, PCR #100 part 3
                                  --+    A "WITH SYSTEM;" may be necessary on
                                  --+    some compilers to use PRAGMA PRIORITY
                                  --+    even though Ada Interpretation
                                  --+    AI-00197 clearly states that it should
                                  --+    NOT be required.

package tk_rzpkg_32 IS
  shared_variable : zg_glob1.integer16 ; 
                 -- In this program no PRAGMA SHARED is specified
                 -- Compare with TK_RZ_TASK_02_NUM_31 where pragma is given

  TASK driver IS
    pragma priority( zg_glob1.priority_2 );
    entry start_program; 
    entry stop_program;
--    entry start_problem ;               --+ tcl April 6 1992 PCR #100, part 2
--    entry stop_problem ;                --+ tcl April 6 1992 PCR #100, part 2
  END driver ; 

  TASK task_1 IS
    pragma priority( zg_glob1.priority_1 );
    entry start_problem ; 
    entry stop_problem ;
    entry stop_program;
  END task_1 ;

  TASK task_2 IS
    pragma priority( zg_glob1.priority_1 );
    entry start_problem ;
    entry stop_problem ;
    entry stop_program;
  END task_2 ;
 
end tk_rzpkg_32 ;

-------------------------------------------------------------------------

package body tk_rzpkg_32 is

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

  TASK body task_1 IS
    exit_loop : boolean := false ;
  begin
   loop
     select 
       accept start_problem do 
         shared_variable := shared_variable + 1 ;
              -- Add one to SHARED_VARIABLE 500 times, subtract one 500 times.
              -- Want to reference it multiple times within rendezvous so that
              -- if the overheads of referencing a shared variable are large,
              -- they will not be swamped by the time to perform the initial
              -- rendezvous.
         zg_glob4.ii := zg_glob4.ei;
         for i in zg_glob1.integer16'(1) .. zg_glob1.integer16'(1000) 
         loop
           if zg_glob3.boolean_false then  -- never taken
             delay 1.0 ;
             shared_variable := shared_variable - zg_glob4.ii ;
             zg_glob3.boolean_false := not zg_glob3.boolean_false;
             zg_glob4.proc0; 
           else
             zg_glob4.ii := - zg_glob4.ii;
           end if;
           shared_variable := shared_variable + zg_glob4.ii; 
         end loop;
       end start_problem; 

       for i in zg_glob4.e1'first .. zg_glob4.e1'last - 1 
       loop
         zg_glob4.e1(i) := zg_glob4.e1(i+1); 
       end loop;

       if zg_glob3.boolean_false then
         zg_glob3.boolean_false := not zg_glob3.boolean_false;
         zg_glob4.xx := 0.0; 
         for i in zg_glob4.e1'range
         loop
           zg_glob4.xx := zg_glob4.xx + zg_glob4.e1(i);
         end loop;
       end if;
      
       accept stop_problem ;
     or
       accept stop_program 
         do
           exit_loop := true; 
         end;
     end select;
     exit when exit_loop;
  end loop;
  
  END task_1 ;

  TASK body task_2 IS
    exit_loop : boolean := false ;
  begin
   loop
     select 
       accept start_problem do 
         shared_variable := shared_variable + 1 ;
              -- Add one to SHARED_VARIABLE 500 times, subtract one 500 times.
              -- Want to reference it multiple times within rendezvous so that
              -- if the overheads of referencing a shared variable are large,
              -- they will not be swamped by the time to perform the initial
              -- rendezvous.
         zg_glob4.ii := zg_glob4.ei;
         for i in zg_glob1.integer16'(1) .. zg_glob1.integer16'(1000) 
         loop
           if zg_glob3.boolean_false then  -- never taken
             delay 1.0 ;
                   --+ tcl PCR #100, part 2, replaced the commented out line
                   --  with the line following it to make problem comparable to
                   --  TK_RZ_TASK_02_NUM_31
             --shared_variable := 0;                 
             shared_variable := shared_variable - zg_glob4.ii ; 

             zg_glob3.boolean_false := not zg_glob3.boolean_false;
             zg_glob4.proc0;
           else
             zg_glob4.ii := - zg_glob4.ii;
           end if;
           shared_variable := shared_variable + zg_glob4.ii; 
         end loop;
       end start_problem; 

       for i in zg_glob4.e1'first .. zg_glob4.e1'last - 1 
       loop
         zg_glob4.e1(i) := zg_glob4.e1(i+1); 
       end loop;

       if zg_glob3.boolean_false then
         zg_glob3.boolean_false := not zg_glob3.boolean_false;
         zg_glob4.xx := 0.0; 
         for i in zg_glob4.e1'range
         loop
           zg_glob4.xx := zg_glob4.xx + zg_glob4.e1(i);
         end loop;
       end if;
      
       accept stop_problem ;
     or
       accept stop_program 
         do
           exit_loop := true; 
         end;
     end select;
     exit when exit_loop;
  end loop;
  
  END task_2 ;

  TASK BODY driver IS
  BEGIN
  
    accept start_program;
 
----------------------------------------------------------------------------
    -- Test Name         :  TK_RZ_TASK_02_NUM_32
    -- Prime Purpose     :  Test the overhead of updating a non-shared variable
    --                      within a rendezvous. This problem differs from
    --                      TK_RZ_TASK_02_NUM_31 only in that it does not 
    --                      specify a PRAGMA SHARED for the modified variable.
    -- Optimization      :
    -- Related Tests     :  TK_RZ_TASK_02_NUM_31
    -- Author            :  T. Leavitt, 
    -- Reviewer          :  B. Decker-Lindsey  -  3 March 1992
    -- Date              :  December 1991
    -- Source            :  Test for this feature was recommended in CECOM 
    --                      report "Evaluation of the ACEC Benchmark Suite 
    --                      for Real-Time Applications." CIN:C02 092LY 0003 00, 
    --                      23 July 1990
    -- Dependencies      :  Support for PRAGMA SHARED
    -- Other Information :  
    -- Revision          :  PCR #100
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Julie Leastman - 15 April 1992 
    -- Date              :  6 April 1992
    -- Change            :  Replaced line "shared_variable := 0;" with the line
    --                      "shared_variable := shared_variable - zg_glob4.ii;"
    --                      to make problem more comparable to 
    --                      TK_RZ_TASK_02_NUM_31. Removed unneeded WITH clauses
    --                      from procedure TK_RZ_TASK_02_NUM_32.
  
----------------------------------------------------------------------------

    zg_glob2.put_test_name("tk_rz_task_02_num_32 ");
    PRAGMA include("startime");
      shared_variable := 0;
      task_1.start_problem; 
      task_2.start_problem; 
      task_2.stop_problem; 
      task_1.stop_problem; 
      task_2.start_problem; 
      task_1.start_problem; 
      task_1.stop_problem; 
      task_2.stop_problem; 
      if shared_variable /= 4 then 
        zg_glob4.die; 
      end if;
    PRAGMA include("stoptime0");
      zg_glob2.put_comment_optional(
        "   Updates a variable within a rendezvous which does  ");
      zg_glob2.put_new_line_optional;
      zg_glob2.put_comment_optional(
        "   not have PRAGMA SHARED specified. cf TK_RZ_TASK_02_NUM_31");
      zg_glob2.put_new_line_optional;
      zg_glob2.put_comment_optional(
        "   Makes 8008 references to variable so that the rendezvous ");
      zg_glob2.put_new_line_optional;
      zg_glob2.put_comment_optional(
        "   will not dominate time. ");
      zg_glob2.put_new_line_optional;
    PRAGMA include("stoptime2");

    task_1.stop_program; 
    task_2.stop_program; 

  accept stop_program; 

  end driver ;

end tk_rzpkg_32 ;

--------------------------------------------------------------------------------

--with zg_glob1;                  --+ tcl 7 April 1992, PCR #100 part 3
--use  zg_glob1;                  --+ tcl 7 April 1992, PCR #100 part 3
--with zg_glob2;                  --+ tcl 7 April 1992, PCR #100 part 3
--with zg_glob3;                  --+ tcl 7 April 1992, PCR #100 part 3
--with zg_glob4;                  --+ tcl 7 April 1992, PCR #100 part 3
--with calendar;                  --+ tcl 7 April 1992, PCR #100 part 3
--use  calendar;                  --+ tcl 7 April 1992, PCR #100 part 3
--with system;                    --+ tcl 7 April 1992, PCR #100 part 3
                                  --+    A "WITH SYSTEM;" may be necessary on
                                  --+    some compilers to use PRAGMA PRIORITY
                                  --+    even though Ada Interpretation
                                  --+    AI-00197 clearly states that it should
                                  --+    NOT be required.
with tk_rzpkg_32 ;

procedure tk_rz_task_02_num_32 is

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

BEGIN
  tk_rzpkg_32.driver.start_program;
  tk_rzpkg_32.driver.stop_program;
END tk_rz_task_02_num_32 ; 
