--+ KET 9/14/89 modified to correct Eilers #7

-- tk_ss_task_56 adequate task STORAGE_SIZE specified by static expression

WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;

with CALENDAR;
use CALENDAR;

procedure tk_ss_task_56  is

  --  Note that there are no suppression pragmas.  Storage_checking is required

  --+ KET 10/19/89 modified during review
  --+ ILLEGAL_ADA1,    
  ILLEGAL_ADA2, ILLEGAL_ADA3, ILLEGAL_ADA4 : exception;

  --+ KET 9/14/89 modified to correct Eilers #7
  --+ error_flag: boolean := false;

  task type SIMPLE_TASK is
  end SIMPLE_TASK;
  for SIMPLE_TASK'STORAGE_SIZE use INTEGER (1024);   -- should be sufficient for
                                                  -- simple procedure call
  task body SIMPLE_TASK is
  begin
    zg_glob4.PROC0;
  end SIMPLE_TASK;

begin


  --
  -- Test Name         :  tk_ss_task_56 
  -- Prime Purpose     :  To measure the time required when a task specifies an 
  --                      adequate STORAGE_SIZE with a static expression. The 
  --                      task body performs a simple call on proc0.
  -- LRM Version       :  Revision A
  -- Optimization      :  
  -- Related tests     :  tk_ss_task_54_mod
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :  
  -- Source            :  
  -- Dependencies      :  
  -- Other Information :  
  --

  ----------------------------------------------------------------------------
  zg_glob2.put_test_name ("tk_ss_task_56");

  pragma INCLUDE ("startime");

  begin
    declare
      ATTEMPTED_TASK : SIMPLE_TASK;
    begin
      null;           -- should get here, no problem with space     
    exception
      when others => -- SHOULD NOT GET HERE,                       
                          -- No exception should have been raised in the
                          -- block, so this handler should not be entered.
        raise ILLEGAL_ADA2;
    end;

    --+ KET 9/14/89 modified to correct Eilers #7                               
    --+    if error_flag then                                                  
    --+ KET 10/19/89 modified during review
    --+       raise ILLEGAL_ADA1; -- execution should never reach here!        
    --+    end if;                                                             

  exception                -- no handler should be entered               
    --+ KET 10/19/89 modified during review
    --+       when ILLEGAL_ADA1 | ILLEGAL_ADA2 | ILLEGAL_ADA3 | ILLEGAL_ADA4 =>
    when ILLEGAL_ADA2 | ILLEGAL_ADA3 | ILLEGAL_ADA4 =>
      raise ;            -- SHOULD NOT GET HERE               
    when STORAGE_ERROR | TASKING_ERROR => -- SHOULD GET HERE  
      raise;
    when CONSTRAINT_ERROR | NUMERIC_ERROR | PROGRAM_ERROR =>
      raise ILLEGAL_ADA4;-- SHOULD NOT GET HERE               
    when others =>       -- SHOULD NOT GET HERE               
      raise ILLEGAL_ADA3;-- implementation defined exception message
  end;

  pragma INCLUDE ("stoptime0");

  zg_glob2.put_comment_optional
	("   adequate task STORAGE_SIZE using static expression");
  zg_glob2.put_new_line_optional;

  pragma INCLUDE ("stoptime2");
  ----------------------------------------------------------------------------

exception
  when others =>
    zg_glob2.put_comment 
	("   adequate task STORAGE_SIZE using static expression");
    zg_glob2.put_new_line;
    zg_glob2.put_comment 
	("   EXCEPTION WAS RAISED WHEN THERE WAS ADEQUATE SPACE REQUESTED!");
    zg_glob2.put_error_code ( zg_glob1.ERR_AT_EXECUTION_TIME );
end tk_ss_task_56;
