WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
 
PROCEDURE xh_eh_except_handl_08 IS

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

BEGIN
  --
  -- Test Name         :  xh_eh_except_handl_08
  -- Prime Purpose     :  conditional raise of user defined exception and go
  --                      through handler.  Not taken.  Compare with 
  --                      xh_eh_except_handl_07, where exception is raised.
  -- LRM Version       :  Revision A
  -- Optimization      :
  -- Related tests     :  xh_eh_except_handl_07
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :  18 Sep 1989
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
 
  
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("xh_eh_except_handl_08");
  PRAGMA include("startime");
  DECLARE                                    -- cf xh_eh_except_handl_07
    ex : EXCEPTION;
  BEGIN
    zg_glob4.proc0;
    IF zg_glob4.mm /= zg_glob4.ll THEN       -- always taken
      RAISE ex;
    END IF;
   -- an optimizing compiler may translate this to a jump into exception 
   -- handler, since the handler is in the same frame and does need to setup 
   -- for propagating the exception. This may take about the same time as 
   -- xh_eh_except_handl_07.
    zg_glob4.proc0;
  EXCEPTION
    WHEN ex =>
      zg_glob4.proc0;
  END;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
  "   DECLARE   ex : EXCEPTION;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   BEGIN   proc0;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "     IF mm/=ll THEN raise ex; END IF; -- always taken");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "     proc0;");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   EXCEPTION");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "     WHEN ex=>   proc0;   end;  -- cf xh_eh_except_handl_07");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------

END xh_eh_except_handl_08 ;  
