WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
 
PROCEDURE xh_en_except_num_err_02 IS

--no checking suppressed

BEGIN
  --
  -- Test Name         :  xh_en_except_num_err_02
  -- Prime Purpose     :  force divide by zero and process exception
  -- LRM Version       :  Revision A
  -- Optimization      :
  -- Related tests     :
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Thomas M. Lee
  -- Date              :  October 10, 1989
  -- Source            :
  -- Dependencies      :
  -- Other Information :
  --
 

    DECLARE
      SUBTYPE mytype IS zg_glob1.integer16 RANGE 15000 .. 15001;
      a : mytype;
    BEGIN
      a := mytype(zg_glob4.ei);     -- not in range, ei has value "1"
                           -- this assignment should raise CONSTRAINT_ERROR
 
      zg_glob2.put_comment("   The system is NOT performing range checks. ");
      zg_glob2.put_new_line;
      zg_glob2.put_comment(
            "   This is either an implementation error or the program was ");
      zg_glob2.put_new_line;
      zg_glob2.put_comment(
            "   improperly compiled with options requesting suppression of ");
      zg_glob2.put_new_line;
      zg_glob2.put_comment("   constraint checking. ");
      zg_glob2.put_new_line(2);
      zg_glob2.put_comment(
             "   User should verify compiler option settings and recompile if");
      zg_glob2.put_new_line;
      zg_glob2.put_comment("   needed. ");
      zg_glob2.put_new_line(2);
 
      zg_glob2.put_test_name("xh_en_except_num_err_02");
      zg_glob2.put_comment(
              "   ERROR - system is suppressing all range checking ");
      zg_glob2.put_new_line;
      zg_glob2.put_error_code(zg_glob1.err_at_execution_time);
      zg_glob1.bool := false;
    EXCEPTION
      WHEN constraint_error =>
        zg_glob1.bool := true;
    END;
 
    IF NOT zg_glob1.bool THEN   -- if system is suppressing range checking
      raise program_error; 
    END IF;                     -- no point in proceeding
  
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("xh_en_except_num_err_02");
  PRAGMA include("startime");
  BEGIN
    zg_glob4.ii := zg_glob4.ei;
    WHILE zg_glob4.ii > 0 LOOP
      zg_glob4.ii := zg_glob4.ii - 1;
      zg_glob4.jj := zg_glob4.ll / zg_glob4.ii; 
           -- this will be a divide by zero
      zg_glob4.ii := -1;     -- this assignment kills the earlier one
                             -- permitting it to be optimized out
    END LOOP;
    zg_glob4.ii := -2;       -- this should never be reached
  EXCEPTION
    WHEN numeric_error | constraint_error =>
      zg_glob4.ei := 1;
  END;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
  "   --divide by zero and process resulting exception");
  zg_glob2.put_new_line_optional;
  IF zg_glob4.ii = -2 THEN
    zg_glob2.put_comment("   --divided by zero without qualm");
    zg_glob2.put_new_line;
    zg_glob2.put_error_code(zg_glob1.ERR_at_execution_time);
  ELSIF zg_glob4.ii = -1 THEN
    zg_glob2.put_error_code(zg_glob1.ERR_at_execution_time);
  ELSIF zg_glob4.ii = 0 THEN          -- expected result
    NULL;
  ELSIF zg_glob4.ii = 1 THEN
    zg_glob2.put_comment("   suppressed store");
    zg_glob2.put_new_line;
    zg_glob2.put_error_code(zg_glob1.ERR_at_execution_time);
  ELSE
    zg_glob2.put_error_code(zg_glob1.ERR_at_execution_time);
  END IF;
  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------
  

END xh_en_except_num_err_02 ;  
