with zg_glob1;
use  zg_glob1;
with zg_glob2;
with zg_glob3;
with zg_glob4;
WITH calendar;
USE  calendar;
with xh_enpkg_03 ; 
 
PROCEDURE xh_en_except_num_err_03 IS
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
BEGIN
 
declare
  t1 : xh_enpkg_03.background_task;
begin

--------------------------------------------------------------------------------
  -- Test Name         :  XH_EN_EXCEPT_NUM_ERR_03
  -- Prime Purpose     :  This problem measures the time to respond to a 
  --                      numeric trap (raise CONSTRAINT_ERROR or NUMERIC_ERROR 
  --                      after dividing by zero) when there is one active 
  --                      task in the background. 
  -- LRM Version       :  Revision A
  -- Optimization      :  
  -- Related tests     :  
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  ???
  -- Date              :  ???
  -- Source            :  CECOM recommendation from "Final Report - Evaluation
  --                      of the ACEC Benchmark Suite for Real-Time
  --                      Applications" July 1990
  -- Dependencies      :
  -- Other Information :
-------------------------------------------------------------------

  t1.sync; 
  delay 1.0;        -- delay to permit background_tasks to start
  zg_glob2.put_test_name("xh_en_except_num_err_03 ");
  PRAGMA include("startime");
    begin
      zg_glob4.xx := 10.0 / (zg_glob4.one-1.0) ; -- will force a divide by zero
      zg_glob4.ii := 1;
      zg_glob4.proc0;
    exception when CONSTRAINT_ERROR | NUMERIC_ERROR  => 
      zg_glob4.ii := 0; 
      zg_glob4.proc0;
    end;
    if zg_glob4.ii /= 0 then zg_glob4.die; end if;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional("   Zero divide with one task in background ");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  t1.stop_task;
end; 

end xh_en_except_num_err_03 ;
