with zg_glob1;
use  zg_glob1;
with zg_glob2;
with zg_glob3;
with zg_glob4;
WITH calendar;
USE  calendar;
with xh_enpkg_03 ; 
 
PROCEDURE xh_en_except_num_err_04 IS
  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);
 
BEGIN
 
----------------------------------------------------------------------------

declare
  t1, t2, t3, t4, t5, t6, t7, t8, t9, t10 : xh_enpkg_03.background_task;
begin

--------------------------------------------------------------------------------
  -- Test Name         :  XH_EN_EXCEPT_NUM_ERR_04
  -- Prime Purpose     :  This problem measures the time to respond to a 
  --                      numeric trap (raise CONSTRAINT_ERROR or NUMERIC_ERROR 
  --                      after dividing by zero) when there are ten active 
  --                      task in the background. 
  -- LRM Version       :  Revision A
  -- Optimization      :  
  -- Related tests     :  
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  ???
  -- Date              :  ???
  -- Source            :  CECOM recommendation from "Final Report - Evaluation
  --                      of the ACEC Benchmark Suite for Real-Time
  --                      Applications" July 1990
  -- Dependencies      :
  -- Other Information :

  t1 .sync;
  t2 .sync;
  t3 .sync;
  t4 .sync;
  t5 .sync;
  t6 .sync;
  t7 .sync;
  t8 .sync;
  t9 .sync;
  t10.sync;
  delay 1.0;        -- delay to permit background_tasks to start
  zg_glob2.put_test_name("xh_en_except_num_err_04 ");
  PRAGMA include("startime");
    begin
      zg_glob4.xx := 10.0 / (zg_glob4.one-1.0) ; -- will force a divide by zero
      zg_glob4.ii := 1;
      zg_glob4.proc0;
    exception when others => 
      zg_glob4.ii := 0; 
      zg_glob4.proc0;
    end;
    if zg_glob4.ii /= 0 then zg_glob4.die; end if;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional("   Zero divide with ten tasks in background ");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  t1 .stop_task;
  t2 .stop_task;
  t3 .stop_task;
  t4 .stop_task;
  t5 .stop_task;
  t6 .stop_task;
  t7 .stop_task;
  t8 .stop_task;
  t9 .stop_task;
  t10.stop_task;
end; 

END xh_en_except_num_err_04 ;
