WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
 
PROCEDURE xh_pn_prgma_num_err_04 IS

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  ------------pragma suppress(division_check);
  ------------pragma suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

BEGIN
  DECLARE
  -- no suppression on overflow_check, division_check
  BEGIN
    --
    -- Test Name         :  xh_pn_prgma_num_err_04
    -- Prime Purpose     :  evaluate effect of selectively suppressing
    --                      combinations of division_check, overflow_check.
    --                      This problem enables division_check, overflow_check
    --                      on integer16 REM.
    -- LRM Version       :  Revision A
    -- Optimization      :
    -- Related tests     :
    -- Author            :  Thomas C. Leavitt
    -- Reviewer          :  Thomas M. Lee
    -- Date              :  October 16, 1989
    -- Source            :
    -- Dependencies      :
    -- Other Information :
    --

    DECLARE
    BEGIN
      zg_glob4.xx := 1.0/zg_glob1.zero;
         -- this assignment should raise DIVISION_ERROR
 
      zg_glob2.put_comment("   The system is NOT performing DIVISION checks. ");
      zg_glob2.put_new_line;
      zg_glob2.put_comment(
            "   This is either an implementation error or the program was ");
      zg_glob2.put_new_line;
      zg_glob2.put_comment(
            "   improperly compiled with options requesting suppression of ");
      zg_glob2.put_new_line;
      zg_glob2.put_comment("   division/overflow checking. ");
      zg_glob2.put_new_line(2);
      zg_glob2.put_comment(
             "   User should verify compiler option settings and recompile if");
      zg_glob2.put_new_line;
      zg_glob2.put_comment("   needed. ");
      zg_glob2.put_new_line(2);
 
      zg_glob2.put_test_name("xh_pn_prgma_num_err_04");
      zg_glob2.put_comment(
              "   ERROR - system is suppressing all division checking ");
      zg_glob2.put_new_line;
      zg_glob2.put_error_code(zg_glob1.err_at_execution_time);
      zg_glob1.bool := false;
    EXCEPTION
      WHEN numeric_error | constraint_error =>
        zg_glob1.bool := true;
    END;
 
    IF NOT zg_glob1.bool THEN   
          -- if system is suppressing division/overflow checking
      raise program_error; 
    END IF;                     -- no point in proceeding
   
    ----------------------------------------------------------------------------
    zg_glob2.put_test_name("xh_pn_prgma_num_err_04");
    PRAGMA include("startime");
    zg_glob4.ii := zg_glob4.ll REM zg_glob4.mm;
    PRAGMA include("stoptime0");
    zg_glob2.put_comment_optional(
    "   ii := ll rem mm;   -- enable division_check, overflow_check");
    zg_glob2.put_new_line_optional;
    PRAGMA include("stoptime2");
    ----------------------------------------------------------------------------
  END;
END xh_pn_prgma_num_err_04 ;  
