WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob4;
USE  zg_glob4;
 
PACKAGE pkg01_xh_pr01 IS
  SUBTYPE one_to_ten IS zg_glob1.integer16 RANGE 1 .. 10;
 
  one_to_ten_x       : one_to_ten := 1;
  one_to_ten_y       : one_to_ten := 1;
  v                  : zg_glob1.integer16        := 5;
 
  a                  : ARRAY(one_to_ten) OF zg_glob1.integer16;
 
  PROCEDURE xh_pr_firth7;
END pkg01_xh_pr01;
 
PACKAGE BODY pkg01_xh_pr01 IS
  
  PROCEDURE xh_pr_firth7 IS
  BEGIN
    one_to_ten_x := 1;
    one_to_ten_y := one_to_ten_x;
    zg_glob4.proc0;
    one_to_ten_x := one_to_ten_x + 1;
    IF zg_glob4.mm IN 1 .. 10 THEN
      one_to_ten_x := zg_glob4.mm;
    END IF;
    FOR i IN a'RANGE LOOP
      a(i) := 0;
    END LOOP;
    one_to_ten_x := v;
    one_to_ten_y := v;
  END xh_pr_firth7;
 
END pkg01_xh_pr01;
 
----------------
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
WITH pkg01_xh_pr01;
USE  pkg01_xh_pr01;
 
PROCEDURE xh_pr_firth7 IS

--no suppression

BEGIN
  --
  -- Test Name         :  xh_pr_firth7
  -- Prime Purpose     :  Example where constant folding and value propagation
  --                      will have a large payoff.
  -- LRM Version       :  A
  -- Optimization      :
  -- Related tests     :  xh_pr_firth7x
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :
  -- Source            :  Adapted from R. Firth annotated examples, December 
  --                      1988
  -- Dependencies      :
  -- Other Information :
  --
 
  ------------   test to ensure that program was not compiled with all
  ------------   constraint checking suppressed

    DECLARE
      SUBTYPE mytype IS zg_glob1.integer16 RANGE 15000 .. 15001;
      a : mytype;
    BEGIN
      a := mytype(zg_glob4.ei);     -- not in range, ei has value "1"
                           -- this assignment should raise CONSTRAINT_ERROR
 
      zg_glob2.put_comment("   The system is NOT performing range checks. ");
      zg_glob2.put_new_line;
      zg_glob2.put_comment(
            "   This is either an implementation error or the program was ");
      zg_glob2.put_new_line;
      zg_glob2.put_comment(
            "   improperly compiled with options requesting suppression of ");
      zg_glob2.put_new_line;
      zg_glob2.put_comment("   constraint checking. ");
      zg_glob2.put_new_line(2);
      zg_glob2.put_comment(
             "   User should verify compiler option settings and recompile if");
      zg_glob2.put_new_line;
      zg_glob2.put_comment("   needed. ");
      zg_glob2.put_new_line(2);
 
      zg_glob2.put_test_name("xh_pr_firth7");
      zg_glob2.put_comment(
              "   ERROR - system is suppressing all range checking ");
      zg_glob2.put_new_line;
      zg_glob2.put_error_code(zg_glob1.err_at_execution_time);
      zg_glob1.bool := false;
    EXCEPTION
      WHEN constraint_error =>
        zg_glob1.bool := true;
    END;
 
    IF NOT zg_glob1.bool THEN   -- if system is suppressing range checking
      raise program_error; 
    END IF;                     -- no point in proceeding
  
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("xh_pr_firth7");
  PRAGMA include("startime");
  pkg01_xh_pr01.xh_pr_firth7;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
  "   --Constraint check optimization. This problem has several statements");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   --where a compiler optimizing constraint checking could eliminate or");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   --simplify some testing code. This problem does NOT suppress constraint");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   --checking. Calls on an external function to inhibit loop invariant");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   --motion optimization.   cf xh_pr_firth7x. ");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------

END xh_pr_firth7 ;  
