WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob4;
USE  zg_glob4;
 
PACKAGE pkg01_xh_pr02 IS
  SUBTYPE one_to_ten IS zg_glob1.integer16 RANGE 1 .. 10;
  a       : ARRAY(one_to_ten) OF zg_glob1.integer16;
  x, y, v : zg_glob1.integer16 := 5;
  PROCEDURE firth7x_proc;
END pkg01_xh_pr02;
 
PACKAGE BODY pkg01_xh_pr02 IS
  PROCEDURE firth7x_proc IS
    PRAGMA suppress(access_check);
    PRAGMA suppress(discriminant_check);
    PRAGMA suppress(index_check);
    PRAGMA suppress(length_check);
    PRAGMA suppress(range_check);
    PRAGMA suppress(division_check);
    PRAGMA suppress(overflow_check);
    PRAGMA suppress(elaboration_check);
    PRAGMA suppress(storage_check);
  BEGIN
    x := 1;
    y := x;
    zg_glob4.proc0;
    IF x < 10 THEN
      x := x + 1;
    ELSE
      RAISE constraint_error;
    END IF;
 
    IF zg_glob4.mm IN 1 .. 10 THEN
      x := zg_glob4.mm;
    END IF;
 
    --  the check implied by the following line should be performed at compile
    --  time if a'first < 1 or else a'last > 10 then raise constraint_error; 
    --  end if;
    FOR i IN a'RANGE LOOP
      a(i) := 0;
    END LOOP;
 
    IF v IN 1 .. 10 THEN
      x := v;
      y := v;
    ELSE
      RAISE constraint_error;
    END IF;
  END firth7x_proc;
 
END pkg01_xh_pr02;
 
----------------
WITH zg_glob1;
USE  zg_glob1;
WITH zg_glob2;
USE  zg_glob2;
WITH zg_glob3;
USE  zg_glob3;
WITH zg_glob4;
USE  zg_glob4;

WITH calendar;
USE  calendar;
WITH pkg01_xh_pr02;
USE  pkg01_xh_pr02;
 
PROCEDURE xh_pr_firth7x IS

  PRAGMA suppress(access_check);
  PRAGMA suppress(discriminant_check);
  PRAGMA suppress(index_check);
  PRAGMA suppress(length_check);
  PRAGMA suppress(range_check);
  PRAGMA suppress(division_check);
  PRAGMA suppress(overflow_check);
  PRAGMA suppress(elaboration_check);
  PRAGMA suppress(storage_check);

BEGIN
  --
  -- Test Name         :  xh_pr_firth7x
  -- Prime Purpose     :  Hand optimized version of xh_pr_firth7 for 
  --                      comparison.
  -- LRM Version       :  A
  -- Optimization      :
  -- Related tests     :  xh_pr_firth7
  -- Author            :  Thomas C. Leavitt
  -- Reviewer          :  Kermit E. Terrell
  -- Date              :
  -- Source            :  Adapted from R. Firth annotated examples, December 
  --                      1988
  -- Dependencies      :
  -- Other Information :
  --


  DECLARE
    SUBTYPE mytype IS zg_glob1.integer16 RANGE 15000 .. 15001;
    a : mytype;
  BEGIN
    a := mytype(zg_glob4.ei); -- not in range, ei has a value "1"
                              -- this assignment should raise CONSTRAINT_ERROR
    zg_glob4.proci1(zg_glob1.integer16(a));
    zg_glob2.put_ancillary(
    " >>> xh_pr_firth7x constraint checking not performed when "&
    "SUPPRESS specified");
    zg_glob2.put_new_line;
  EXCEPTION
    WHEN constraint_error =>
      zg_glob2.put_ancillary(
      " >>> xh_pr_firth7x constraint checking performed when "&
      "SUPPRESS specified");
      zg_glob2.put_new_line;
      zg_glob2.put_comment_optional(
    "   --xh_pr_firth7x may still contain some constraint checking  ");
      zg_glob2.put_new_line_optional;
      zg_glob2.put_comment_optional(                               
    "   --code for array subscript checking. ");
      zg_glob2.put_new_line_optional;
  END;
 
  ----------------------------------------------------------------------------
  zg_glob2.put_test_name("xh_pr_firth7x");
  PRAGMA include("startime");
  pkg01_xh_pr02.firth7x_proc;
  PRAGMA include("stoptime0");
  zg_glob2.put_comment_optional(
  "   --Hand optimized version of xh_pr_firth7, uses unconstrained types ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   --with explicit checks for the necessary range constraints required ");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   --for comparability with xh_pr_firth7. Call on external function to");
  zg_glob2.put_new_line_optional;
  zg_glob2.put_comment_optional(
  "   --inhibit loop invariant motion optimization.");
  zg_glob2.put_new_line_optional;
  PRAGMA include("stoptime2");
  ----------------------------------------------------------------------------

END xh_pr_firth7x ;  
